'Bambino-05
SERTXD("B05",CR)    'report program number

#PicAxe 20M2
#no_data

'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values

'-----------------------------------------------------------------
Rationale:
'Test Whisker light values
'-------------------------
'  open the Terminal window [F8] to see the values;
'    set the baud to 4800;
'  read the analog light values using READADC
'edit holedetect values so Bambino can see table edges
'detected values should
'be greater than the holedetect values when not at an edge
'and lower when at an edge.
'=================================================================

SYMBOL VoiceLedpin_     =c.5
SYMBOL eyeLedLpin_      =c.2    'low =>LED on
SYMBOL eyeLedRpin_      =b.1    'low =>LED on
SYMBOL GwhiskerLedLpin_ =c.3    'low =>Ground whisker LED on
SYMBOL GwhiskerLedRpin_ =b.3    'low =>Ground whisker LED on
SYMBOL IRinpin          =c.6
SYMBOL IRoutpin         =b.2
SYMBOL eyeRpin          =c.7
SYMBOL eyeLpin          =c.1
SYMBOL GwhiskerLpin     =b.5    'Ground whisker (down) Left
SYMBOL GwhiskerRpin     =b.0    'Ground whisker (down) Right

'edit holedetect values so Bambino can see table edges
'detected values should
'be greater than the holedetect values when not at an edge
'and lower when at an edge
SYMBOL holedetectL =10  '% light level difference for hole
SYMBOL holedetectR =10  '% light level difference for hole
'whisker LEDs on, 82R 1.414v =>17.2mA @4.02V


initialise:
  HIGH GwhiskerLedLpin_   'make output, Ground whisker LED Left off
  HIGH GwhiskerLedRpin_   'make output, Ground whisker LED Right off

start:

ReadGwhiskerL: 'more than 10% change of eyeval with LED on => ground seen
  READADC b.5,B1               'dark eyeval in b1
  LOW GwhiskerLedLpin_         'LED on
  PAUSE 1
  READADC b.5,B2               'light eyeval in b2
  HIGH  GwhiskerLedLpin_       'LED off
  IF B1>B2 THEN ReadGwhiskerL  'interference
  B3 =B2 -B1 *100 /B2          'scale for %
  SERTXD ("L dark=",#b1," light=",#b2," %=",#b3)
                                'send value back to PC
  IF B3<holedetectL THEN
    SERTXD(" edge : ")
   ELSE
     SERTXD(" : ")
   ENDIF

  PAUSE 100

ReadGwhiskerR: 'more than 10% change of eyeval with LED on => ground seen
  READADC b.0,B1               'dark eyeval in b1
  LOW GwhiskerLedRpin_         'LED on
  PAUSE 1
  READADC b.0,B2               'light eyeval in b2
  HIGH  GwhiskerLedRpin_       'LED off
  IF B1>B2 THEN ReadGwhiskerR  'interference
  B3 =B2 -B1 *100 /B2          'scale for %
  SERTXD ("R dark=",#b1," light=",#b2," %=",#b3)
                               'send value back to PC
  IF B3<holedetectR THEN
    SERTXD(" edge",CR)
   ELSE
     SERTXD(CR)
   ENDIF

  PAUSE 100

  GOTO start                   'loop back to start

'=================================================================

