'Bambino-07
SERTXD("B07",CR)    'report program number

#PicAxe 20M2
#no_data

'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position

'-----------------------------------------------------------------
Rationale:
'Servos require a control pulse, nominally between 1ms and 2ms, 
'repeated nominally every 20ms. 
'A pulse of 1.5ms will send a servo to its mid position.
'For a change from 1ms to 2ms the servo will rotate about 100 degrees, 
'the direction and precise amount depends on the make and model of the servo.
'It is not.advisable to pulse servos more often than about every 15ms as some 
'servos will smoke and self destruct. 
'Pulsing at an interval of greater than 30ms will result in 
'sluggish and weak movement.

'Set servos to mid position
'--------------------------
'  remove horn screws
'  remove horns from servos
'  run program
'  attach horns so
'    feet are side by side
'    feet are both flat on the ground
'    fasten the horns with the screws

'=================================================================

SYMBOL servopacepin      =c.0
SYMBOL servorollpin      =c.4
SYMBOL VoiceLedpin_      =c.5
SYMBOL eyeLedLpin_       =c.2    'low =>LED on
SYMBOL eyeLedRpin_       =b.1    'low =>LED on
SYMBOL GwhiskerLedLpin_  =c.3    'low =>Ground whisker LED on
SYMBOL GwhiskerLedRpin_  =b.3    'low =>Ground whisker LED on
SYMBOL eyeRpin           =c.7
SYMBOL eyeLpin           =c.1
SYMBOL IRinpin           =c.6
SYMBOL IRoutpin          =b.2

initialise:
  LOW eyeLedRpin_    'make output
  HIGH eyeLedLpin_   'make output

start:
  TOGGLE eyeLedRpin_        'flash eyeR so we know program is running
  TOGGLE eyeLedLpin_        'flash eyeL so we know program is running
  PULSOUT servopacepin,150  'pulse servo 1.5ms
  PULSOUT servorollpin,150  'pulse servo 1.5ms
  PAUSE 20                  'pause 20ms - see note above
  GOTO start                'loop back to start

'=================================================================
