'Bambino-10
Sertxd("B10",CR)    'report program number

'147 bytes

#PicAxe 20M2
#no_data

'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position
'Bambino-08  Calibrate servo mid positions and put in EEPROM.
'Bambino-08+ Adjust servo mid positions from Handset and put in EEPROM.
'Bambino-09  Introduce _iStand:- initialise with feet in mid position
'Bambino-10  Set rollby, rollbymax for Roll Right

'-----------------------------------------------------------------
Rationale:
'Set rollby for Roll Right
'-------------------------
'edit rollbyR and reload program
'  until left foot is just off the ground

'edit rollby and reload program
'  to find rollby so Bambino just doesn't tip over
'  edit rollbymax to that value

'=================================================================
'modified
'--------
'initialise:
'start
'_iStand

'New
'---
'rollby
'rollspeed
'rollat
'rollto
'paceat   - not used yet
'paceto   - not used yet
'sframe:
'_rollR:
'=================================================================

SYMBOL servopacepin      =c.0    'left connector
SYMBOL servorollpin      =c.4    'right connector
SYMBOL VoiceLedpin_      =c.5
SYMBOL eyeLedLpin_       =c.2    'low =>LED on
SYMBOL eyeLedRpin_       =b.1    'low =>LED on
SYMBOL whiskerLedLpin_   =c.3    'low =>whisker LED on
SYMBOL whiskerLedRpin_   =b.3    'low =>whisker LED on
SYMBOL IRinpin           =c.6
SYMBOL IRoutpin          =b.2

SYMBOL temp0        =B0
'symbol cmnd         =B1
SYMBOL Scentre    =W1
SYMBOL  rollC       =B2  '100 is roll to the left
SYMBOL  paceC       =B3  '100 is left foot back
SYMBOL Sat        =W2    'current servo positions
SYMBOL  rollat      =B4
SYMBOL  paceat      =B5
SYMBOL Sto        =W3    'desired servo positions
SYMBOL  rollto      =B6
SYMBOL  paceto      =B7
SYMBOL i            =B8
SYMBOL spulse       =B9

SYMBOL rollbyR    =15    '15 good for walking
SYMBOL rollbymax  =22
'rollmax absolute max is 40, above that the tilt rods hit the body
SYMBOL rollspeed  =1
SYMBOL sframe     =20  'time between servo pulses

'EEPROM DATA
SYMBOL DrollC   =254
SYMBOL DpaceC   =255


initialise:
  rollC      =150  'Default, 100 is roll to the left, 150 is nominal centre
  paceC      =150  'Default, 100 is left foot back,   150 is nominal centre
  'get values from EEPROM if set by program #8 or #8+
  READ DrollC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    rollC =temp0
   ELSE
    WRITE DrollC,rollC             'save default for other programs
   ENDIF
  READ DpaceC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    paceC =temp0
   ELSE
    WRITE DpaceC,paceC             'save default  for other programs
   ENDIF
  sertxd("rollC=",#rollC," paceC=",#paceC,CR)
  

  LOW eyeLedRpin_   'make output
  HIGH eyeLedLpin_  'make output
  GOSUB _iStand

start:
  TOGGLE eyeLedRpin_  'alter eyeR so we know program is running
  TOGGLE eyeLedLpin_  'alter eyeR so we know program is running
  rollto =rollC +rollbyR
  GOSUB _rollR
  END



_rollR:
  FOR spulse=rollat TO rollto STEP rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat  'pulse servo
    PAUSE sframe
   NEXT spulse
  RETURN

_iStand:
'initialise with feet in mid position
  FOR i=0 TO 20
    PULSOUT servopacepin,paceC  'pulse servo paceC
    PULSOUT servorollpin,rollC  'pulse servo rollC
    PAUSE 70                    'pause 70ms - do it slowly
   NEXT i
   rollat =rollC
  RETURN
  
'=================================================================
  