'Bambino-16
SERTXD("B16",CR)    'report program number

#PicAxe 20M2
#no_data

'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position
'Bambino-08  Calibrate servo mid positions and put in EEPROM.
'Bambino-08+ Adjust servo mid positions from Handset and put in EEPROM.
'Bambino-09  Introduce _iStand:- initialise with feet in mid position
'Bambino-10  Set rollby, rollbymax for Roll Right
'Bambino-11  Check rollby, rollbymax for Roll Left
'Bambino-12  Check rollby and rollbymax for rollL, rollR
'            save rollbyL and rollbyR in EEPROM
'Bambino-13  Introduction of _Stand
'Bambino-14  Investigate effect of rollspeed;
'            watch roll for all three speeds
'Bambino-15  Investigate effect of rollspeed;
'            watch Roll and Stand for all three speeds
'Bambino-16  Check paceby;  Investigate effect of pacespeed

'-----------------------------------------------------------------
Rationale:
'Check paceby
'-------------------
'edit paceby and reload program for nice walking
'edit paceby and check pacebymax, edit paceby back to walking

'Investigate effect of pacespeed
'-------------------------------
'edit pacespeed to see how Bambino performs

'=================================================================
'modified
'--------
'init
'start
'_StandL:
'_StandR
'_rollL
'_rollR

'New
'---
'paceat
'paceby
'pacespeed
'_RF
'_LF
'=================================================================

SYMBOL servopacepin    =c.0 'left connector
SYMBOL servorollpin    =c.4 'right connector
SYMBOL VoiceLedpin_    =c.5
SYMBOL eyeLedLpin_     =c.2 'low =>LED on
SYMBOL eyeLedRpin_     =b.1 'low =>LED on
SYMBOL whiskerLedLpin_ =c.3 'low =>whisker LED on
SYMBOL whiskerLedRpin_ =b.3 'low =>whisker LED on
SYMBOL IRinpin         =c.6
SYMBOL IRoutpin        =b.2

SYMBOL temp0        =B0
'symbol cmnd         =B1
SYMBOL Scentre    =W1
SYMBOL  rollC       =B2  '100 is roll to the left, 200 to the right
SYMBOL  paceC       =B3  '100 is left foot back, 200 left foot forward
SYMBOL Sat        =W2    'current servo positions
SYMBOL  rollat      =B4
SYMBOL  paceat      =B5
SYMBOL Sto        =W3    'desired servo positions
SYMBOL  rollto      =B6
SYMBOL  paceto      =B7
SYMBOL Sspeed     =W4
SYMBOL  rollspeed   =B9  '4 is too fast, 0 won't move
SYMBOL  pacespeed   =B10 '6 is about max for servos to keep up
SYMBOL i            =B11
SYMBOL spulse       =B12
SYMBOL rollby       =B13 '+ve right 15 good for walking
SYMBOL paceby       =B14 '+ve Left foot forward 20@speed 3; 25@speed 1

SYMBOL rollbymax  =20    '@speed 3; 25@speed 1
'rollmax absolute max is 40, above that the tilt rods hit the body
SYMBOL pacebymax  =30
'pacebymax absolute max is 30, 
'above that the tilt rods hit the rear femur 
'and the horn screws hit the leg body
SYMBOL sframe     =20    'time between servo pulses


'EEPROM DATA
SYMBOL DrollbyR =252
SYMBOL DrollbyL =253
SYMBOL DrollC   =254
SYMBOL DpaceC   =255

initialise:
  rollC      =150  'Default, 100 is roll to the left, 150 is nominal centre
  paceC      =150  'Default, 100 is left foot back,   150 is nominal centre
  'get values from EEPROM if set by program #8 or #8+
  READ DrollC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    rollC =temp0
   ELSE
    WRITE DrollC,rollC             'save default for other programs
   endif
  READ DpaceC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    paceC =temp0
   ELSE
    WRITE DpaceC,paceC             'save default  for other programs
   endif
  SERTXD("rollC=",#rollC," paceC=",#paceC,CR)
 SERTXD("roll=",#rollat," pace=",#paceat,CR)

  LOW eyeLedRpin_     'make output
  HIGH eyeLedLpin_    'make output
  GOSUB _iStand       'stand and initialise rollat, paceat

  'rollby     =15    '15 good for walking, READ from EEPROM
  paceby     =28

initspeed:
  rollspeed =1
  pacespeed =4

start:
  TOGGLE eyeLedRpin_  'alter eyeR so we know program is running
  TOGGLE eyeLedLpin_  'alter eyeR so we know program is running
  GOSUB _RF
  PAUSE 500
  GOSUB _LF
  PAUSE 500
  GOTO start


_RF:
  paceto =paceC -paceby
  FOR spulse=paceat TO paceto STEP -pacespeed
    paceat =spulse
    PULSOUT servopacepin,paceat  'pulse servo
    PULSOUT servorollpin,rollat  'pulse servo hold in position
    PAUSE sframe
   NEXT spulse
  RETURN
_LF:
  paceto =paceC +paceby
  FOR spulse=paceat TO paceto STEP pacespeed
    paceat =spulse
    PULSOUT servopacepin,paceat  'pulse servo
    PULSOUT servorollpin,rollat  'pulse servo hold in position
    PAUSE sframe
   NEXT spulse
  RETURN

Stand:                        'stand with both feet flat
  IF rollat<rollC THEN _StandR
_StandL:
  FOR spulse=rollat TO rollC STEP -rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat  'pulse servo
    PAUSE sframe
   NEXT spulse
  RETURN
_StandR:
  FOR spulse=rollat TO rollC STEP rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat  'pulse servo
    PAUSE sframe
   NEXT spulse
  RETURN

_rollL:
  READ DrollbyL,rollby
  rollto =rollC -rollby
  FOR spulse=rollat TO rollto STEP -rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat  'pulse servo
    PAUSE sframe
   NEXT spulse
  RETURN

_rollR:
  READ DrollbyR,rollby
  rollto =rollC +rollby
  FOR spulse=rollat TO rollto STEP rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat 'pulse servo
    PAUSE sframe
   NEXT spulse
  RETURN

_iStand:                       'initialise with feet in mid position
  FOR i=0 TO 20
    PULSOUT servopacepin,paceC 'pulse servo paceC
    PULSOUT servorollpin,rollC 'pulse servo rollC
    PAUSE 70                   'pause 70ms - do it slowly
   NEXT i
  rollat =rollC
  paceat =paceC
  RETURN
  
'=================================================================  