'Bambino-20
SERTXD("B20",CR)    'report program number

'560 bytes

#PicAxe 20M2
#no_data

'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position
'Bambino-08  Calibrate servo mid positions and put in EEPROM.
'Bambino-08+ Adjust servo mid positions from Handset and put in EEPROM.
'Bambino-09  Introduce _iStand:- initialise with feet in mid position
'Bambino-10  Set rollby, rollbymax for Roll Right
'Bambino-11  Check rollby, rollbymax for Roll Left
'Bambino-12  Check rollby and rollbymax for rollL, rollR
'            save rollbyL and rollbyR in EEPROM
'Bambino-13  Introduction of _Stand
'Bambino-14  Investigate effect of rollspeed;
'            watch roll for all three speeds
'Bambino-15  Investigate effect of rollspeed;
'            watch Roll and Stand for all three speeds
'Bambino-16  Check paceFL paceFR;  Investigate effect of pacespeed
'Bambino-17  Check Fd
'Bambino-18  Test Rt, Lt
'Bambino-19  Test Bk
'Bambino-20  Test T2l: TurntoLight: T2d:  TurntoDark: Wl: Wd:

'-----------------------------------------------------------------
Rationale:
'Test TurntoLight:  TurntoDark
'-----------------------------
'One of the simplest tasks a robot like Bambino can do is to walk 
'towards bright lights, or walk towards dark areas.
'Here are introduced 
'walktoLight:, walktoDark:, TurntoLight:, TurntoDark:, QLightDirection:
'these are also called Wd:, Wl:, T2l:, T2d: to save typing.
'To determine the light direction left or right,
'  take readings from the eyes,
'  find the difference
'  shift by 128 to avoid negative numbers,
'  255 is left and 0 is right with 128 straight ahead,
'  for going to light
'    if greater than (128 + eyehyteresis) then turn left
'    if less    than (128 - eyehyteresis) then turn right
'  for going to dark
'    if greater than (128 + eyehyteresis) then turn right
'    if less    than (128 - eyehyteresis) then turn left
'=================================================================
'modified
'--------
'start:

'New
'---
'walktoLight:
'walktoDark:
'TurntoLight:
'TurntoDark:
'QLightDirection:            'Query Light Direction
'SYMBOL eyeRval    =b13
'SYMBOL eyeLval    =b14
'SYMBOL eyediff    =b15
'SYMBOL lightdirection =b16  '255 is left, 128 is ahead, 0 is right 
'SYMBOL eyemapahead  =128  'ahead value for eyemap, 255 left, 0 right
'SYMBOL eyehyteresis =20   'minimum deviation from ahead for action
'  between eyemapminL and eyemapmaxR is a dead band action is Forward
'SYMBOL eyemapminL =eyemapahead +eyehyteresis
'SYMBOL eyemapmaxR =eyemapahead -eyehyteresis
'=================================================================

SYMBOL servopacepin    =c.0  'left connector
SYMBOL servorollpin    =c.4  'right connector
SYMBOL VoiceLedpin_    =c.5
SYMBOL eyeLedLpin_     =c.2
SYMBOL eyeLedRpin_     =b.1
SYMBOL whiskerLedLpin_ =c.3    'low =>whisker LED on
SYMBOL whiskerLedRpin_ =b.3    'low =>whisker LED on
SYMBOL IRinpin         =c.6
SYMBOL IRoutpin        =b.2
SYMBOL eyeRpin         =c.7
SYMBOL eyeLpin         =c.1


SYMBOL temp0        =B0
'symbol cmnd         =B1
SYMBOL Scentre    =W1
SYMBOL  rollC       =B2  '100 is roll to the left, 200 to the right
SYMBOL  paceC       =B3  '100 is left foot back, 200 left foot forward
SYMBOL Sat        =W2    'current servo positions
SYMBOL  rollat      =B4
SYMBOL  paceat      =B5
SYMBOL Sto        =W3    'desired servo positions
SYMBOL  rollto      =B6
SYMBOL  paceto      =B7
SYMBOL Sspeed     =W4
SYMBOL  rollspeed   =B9  '4 is too fast, 0 won't move
SYMBOL  pacespeed   =B10 '6 is about max for servos to keep up
SYMBOL i            =B11
SYMBOL spulse       =B12
SYMBOL eyeRval      =B13
SYMBOL eyeLval      =B14
SYMBOL eyediff      =B15 'difference between R & L eye light levels
SYMBOL lightdirection =B16  '255 is left, 128 is ahead, 0 is right 
SYMBOL rollby       =B17 '+ve right 15 good for walking
SYMBOL paceby       =B18 '+ve Left foot forward 20@speed 3; 25@speed 1

SYMBOL rollbymax  =20    '@speed 3; 25@speed 1
'rollmax absolute max is 40, above that the tilt rods hit the body
SYMBOL pacebymax  =30
'pacebymax absolute max is 30, 
'above that the tilt rods hit the rear femur 
'and the horn screws hit the leg body
SYMBOL sframe     =20    'time between servo pulses
SYMBOL eyemapahead  =128  'ahead value for eyemap, 255 left, 0 right
SYMBOL eyehyteresis =20   'minimum deviation from ahead for action
'between eyemapMinL and eyemapMaxR is a dead band action is forward
SYMBOL eyemapminL =eyemapahead +eyehyteresis
SYMBOL eyemapmaxR =eyemapahead -eyehyteresis


'EEPROM DATA
SYMBOL DrollbyR =252
SYMBOL DrollbyL =253
SYMBOL DrollC   =254
SYMBOL DpaceC   =255



initialise:
  rollC      =150  'Default, 100 is roll to the left, 150 is nominal centre
  paceC      =150  'Default, 100 is left foot back,   150 is nominal centre
  'get values from EEPROM if set by program #8 or #8+
  READ DrollC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    rollC =temp0
   ELSE
    WRITE DrollC,rollC             'save default for other programs
   ENDIF
  READ DpaceC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    paceC =temp0
   ELSE
    WRITE DpaceC,paceC             'save default  for other programs
   ENDIF
  SERTXD("rollC=",#rollC," paceC=",#paceC,CR)
 SERTXD("roll=",#rollat," pace=",#paceat,CR)

  LOW eyeLedRpin_     'make output
  HIGH eyeLedLpin_    'make output
  GOSUB _iStand       'stand and initialise rollat, paceat

  'rollby     =15    '15 good for walking, READ from EEPROM
  paceby     =28

initspeed:
  rollspeed =1
  pacespeed =4


start:
  FOR temp0 =1 TO 20 
    GOSUB walktoLight
   NEXT temp0
  FOR temp0 =1 TO 20 
    GOSUB walktoDark
   NEXT temp0
  GOTO start


Wl:
WalktoLight:
  LOW eyeLedRpin_      'eyeR on for walking to light
  LOW eyeLedLpin_      'eyeL on for walking to light
  GOSUB Fd
  GOSUB TurntoLight
SERTXD(" L=",#eyeLval," R=",#eyeRval," D=",#lightdirection,CR)
  RETURN
Wd:
WalktoDark:             
  LOW whiskerLedRpin_  'whiskerR on for walking to dark
  LOW whiskerLedLpin_  'whiskerL on for walking to dark
  GOSUB Fd
  GOSUB TurntoDark
SERTXD(" L=",#eyeLval," R=",#eyeRval," D=",#lightdirection,CR)
  RETURN

T2l:
TurntoLight:
  GOSUB QLightDirection
  IF lightdirection>eyemapminL THEN
    LOW eyeLedLpin_       'indicate turn 
    GOSUB Lt
   ENDIF 
  IF lightdirection<eyemapmaxR THEN
    LOW eyeLedRpin_       'indicate turn
    GOSUB Rt
   ENDIF 
  RETURN

T2d:
TurntoDark:
  GOSUB QLightDirection
  IF lightdirection>eyemapminL THEN
    LOW whiskerLedRpin_   'indicate turn 
    GOSUB Rt
   ENDIF
  IF lightdirection<eyemapmaxR THEN
    LOW whiskerLedLpin_   'indicate turn 
    GOSUB Lt
   ENDIF 
  RETURN

QLightDirection:        'Query Light Direction
  HIGH eyeLedRpin_      'turn off LED before reding eyes
  HIGH eyeLedLpin_      'turn off LED before reding eyes
  HIGH whiskerLedRpin_  'turn off LED before reding eyes
  HIGH whiskerLedLpin_  'turn off LED before reding eyes
  READADC eyeRpin,eyeRval
  READADC eyeLpin,eyeLval
  eyediff =eyeLval -eyeRval
  'center this on eyemapahead to avoid negative numbers
  'and map onto lightdirection
  lightdirection =eyediff +eyemapahead
  'lightdirection  Left>eyemapahead>Right
  RETURN


Fd:
SERTXD ("F")
  IF paceat<paceC THEN _FdL 'ELSE _FdR
_FdR:
'SERTXD ("_FdR")
  GOSUB _rollL
  GOSUB _RF
  GOSUB Stand
  RETURN
_FdL:
'SERTXD ("_FdL")
  GOSUB _rollR
  GOSUB _LF
  GOSUB Stand
  RETURN


Rt:
SERTXD ("R")
  IF paceat<paceC THEN GOSUB Fd  'need left foot forward
  GOSUB _RF
  RETURN

Lt:
SERTXD ("L")
  IF paceat>paceC THEN GOSUB Fd  'need right foot forward
  GOSUB _LF
  RETURN

_RF:
'SERTXD ("_RF")
  paceto =paceC -paceby
  FOR spulse=paceat TO paceto STEP -pacespeed
    paceat =spulse
    PULSOUT servopacepin,paceat  'pulse servo
    PULSOUT servorollpin,rollat  'pulse servo hold in position
    PAUSE sframe
   NEXT spulse
  RETURN
_LF:
'SERTXD ("_LF")
  paceto =paceC +paceby
  FOR spulse=paceat TO paceto STEP pacespeed
    paceat =spulse
    PULSOUT servopacepin,paceat  'pulse servo
    PULSOUT servorollpin,rollat  'pulse servo hold in position
    PAUSE sframe
   NEXT spulse
  RETURN

Stand:  'stand with both feet flat
SERTXD (" S")
  IF rollat<rollC THEN _StandR 'ELSE _StandL
_StandL:
'SERTXD ("_SL")
  FOR spulse=rollat TO rollC STEP -rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat  'pulse servo
    PULSOUT servopacepin,paceat  'pulse servo hold in position
    PAUSE sframe
   NEXT spulse
  RETURN
_StandR:
'SERTXD ("_SR")
  FOR spulse=rollat TO rollC STEP rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat  'pulse servo
    PULSOUT servopacepin,paceat  'pulse servo hold in position
    PAUSE sframe
   NEXT spulse
  RETURN


_rollL:
'SERTXD ("_rL")
  READ DrollbyL,rollby
  rollto =rollC -rollby
  FOR spulse=rollat TO rollto STEP -rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat  'pulse servo
    PULSOUT servopacepin,paceat  'pulse servo hold in position
    PAUSE sframe
   NEXT spulse
  RETURN

_rollR:
'SERTXD ("_rR")
  READ DrollbyR,rollby
  rollto =rollC +rollby
  FOR spulse=rollat TO rollto STEP rollspeed
    rollat =spulse
    PULSOUT servorollpin,rollat  'pulse servo
    PULSOUT servopacepin,paceat  'pulse servo hold in position
    PAUSE sframe
   NEXT spulse
  RETURN

_iStand:                        'initialise with feet in mid position
  FOR spulse=0 TO 20
    PULSOUT servopacepin,paceC  'pulse servo paceC
    PULSOUT servorollpin,rollC  'pulse servo rollC
    PAUSE 70                    'pause 70ms - do it slowly
   NEXT spulse
  rollat =rollC
  paceat =paceC
  RETURN

'=================================================================
  