'Bambino-22
SERTXD("B22",CR)    'report program number

'673 bytes

#PicAxe 20M2
#no_data

'=================================================================
'PICAXE            IC   Memory   ext  I/O   Outputs  Inputs  ADC  Memory                        Starts  Polled  Resonator
'    Type        pins  bytes    slot pins                        Vars. RAM Spad Data     Table*        Int.    def. opt.
'2.28 PICAXE-20M2  20    2k           18    1-16     1-17     4    28   512      256      512   8       Yes      4   -32

'PICAXE-20M2 circuit board with LEDs off takes 1mA
'PICAXE-20M2 circuit board with LEDs off and servos connected takes 10mA
'=================================================================
'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position
'Bambino-08  Calibrate servo mid positions and put in EEPROM.
'Bambino-08+ Adjust servo mid positions from Handset and put in EEPROM.
'Bambino-09  Introduce _iStand:- initialise with feet in mid position
'Bambino-10  Set rollby, rollbymax for Roll Right
'Bambino-11  Check rollby, rollbymax for Roll Left
'Bambino-12  Check rollby and rollbymax for rollL, rollR
'            save rollbyL and rollbyR in EEPROM
'Bambino-13  Introduction of _Stand
'Bambino-14  Investigate effect of rollspeed;
'            watch roll for all three speeds
'Bambino-15  Investigate effect of rollspeed;
'            watch Roll and Stand for all three speeds
'Bambino-16  Check paceFL paceFR;  Investigate effect of pacespeed
'Bambino-17  Check Fd
'Bambino-18  Test Rt, Lt
'Bambino-19  Test Bk
'Bambino-20  Test T2l: TurntoLight: T2d:  TurntoDark: Wl: Wd:
'Bambino-21  Creaton of sections ACTIONS, BEHAVIOURS, ACTS;
'            Introduction of ACT parameter 'Ado'
'Bambino-22  Demo routine + example use of Start1: to flash eyes

'-----------------------------------------------------------------
Rationale:
'StartX (see Manual1 page 61) can be used for multitasking
'here it is used to flash the eyes whilst walking.
'Later programs do not use Starts because there was nothing I wanted
'Bambino to do in parallel.
'StartX is not useful for pulsing the servos.
'Also it should be noted that the PicAxe Servo command for pulsing 
'the servos as a background task is not reliable for more than 
'one servo and causes the servos to judder.
'=================================================================
'modified
'--------
'start:

'New
'---
'Beep150
'==========================================================
SYMBOL servopace    =c.0  'left connector
SYMBOL servoroll    =c.4  'right connector
SYMBOL VoiceLed_    =c.5  'low =>LED on
SYMBOL eyeLedL_     =c.2  'low =>LED on
SYMBOL eyeLedR_     =b.1  'low =>LED on
SYMBOL whiskerLedL_ =c.3  'low =>whisker LED on
SYMBOL whiskerLedR_ =b.3  'low =>whisker LED on
SYMBOL inIR         =c.6
SYMBOL outIR        =b.2
SYMBOL eyeR         =c.7
SYMBOL eyeL         =c.1


SYMBOL temp0        =B0
'symbol cmnd         =B1
SYMBOL Scentre    =W1
SYMBOL  rollC       =B2  '100 is roll to the left, 200 to the right
SYMBOL  paceC       =B3  '100 is left foot back, 200 left foot forward
SYMBOL Sat        =W2    'current servo positions
SYMBOL  rollat      =B4
SYMBOL  paceat      =B5
SYMBOL Sto        =W3    'desired servo positions
SYMBOL  rollto      =B6
SYMBOL  paceto      =B7
SYMBOL Sspeed     =W4
SYMBOL  rollspeed   =B9  '4 is too fast, 0 won't move
SYMBOL  pacespeed   =B10 '6 is about max for servos to keep up
SYMBOL i            =B11
SYMBOL spulse       =B12
SYMBOL eyeRval      =B13
SYMBOL eyeLval      =B14
SYMBOL eyediff      =B15
SYMBOL Ado          =B16 'parameter for Acts
SYMBOL rollby       =B17 '+ve right 15 good for walking
SYMBOL paceby       =B18 '+ve Left foot forward 20@speed 3; 25@speed 1

SYMBOL rollbymax  =20    '@speed 3; 25@speed 1
'rollmax absolute max is 40, above that the tilt rods hit the body
SYMBOL pacebymax  =30
'pacebymax absolute max is 30, above that the tilt rods hit the rear femur and the horn screws hit the leg body
SYMBOL sframe     =20    'time between servo pulses


'EEPROM DATA
SYMBOL DrollbyR =252
SYMBOL DrollbyL =253
SYMBOL DrollC   =254
SYMBOL DpaceC   =255

GOTO initialise   ' jump round Starts    IMPORTANT !!!
'==========================================================
'All startX run automatically on PowerOn
'Start0 default main
'Start1 toggle eyes
Start1:
togleyes:
  GOSUB ToggleEyes  'alter eyeR so we know program is running
  PAUSE 100
  GOTO togleyes
'==========================================================

initialise:
  rollC      =150  'Default, 100 is roll to the left, 150 is nominal centre
  paceC      =150  'Default, 100 is left foot back,   150 is nominal centre
  'get values from EEPROM if set by program #8 or #8+
  READ DrollC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    rollC =temp0
   ELSE
    WRITE DrollC,rollC             'save default for other programs
   ENDIF
  READ DpaceC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    paceC =temp0
   ELSE
    WRITE DpaceC,paceC             'save default  for other programs
   ENDIF
  SERTXD("rollC=",#rollC," paceC=",#paceC,CR)
  SERTXD("roll=",#rollat," pace=",#paceat,CR)

  LOW eyeLedR_     'make output
  HIGH eyeLedL_    'make output
  GOSUB _iStand    'stand and initialise rollat, paceat

  'rollby     =15    '15 good for walking, READ from EEPROM
  paceby     =28

initspeed:        'changed by speed behaviour
  GOSUB B_fast

start:
  GOSUB beep150
'#rem
  Ado =4
  GOSUB RockAdo
  GOSUB Stand
  Ado =8
  GOSUB FdAdo
  Ado =8
  GOSUB BkAdo

'  goto start
'#endrem
  GOSUB ToggleEyes  'alter eyeR so we know program is running
  GOSUB B_fast
  GOSUB Fd
  GOSUB Fd
  GOSUB Fd
  GOSUB Fd
  GOSUB EyeRon
  GOSUB B_turn
  GOSUB Rt
  GOSUB Rt
  GOSUB Rt
  GOSUB Rt
  GOSUB EyesON
  GOSUB B_fast
  GOSUB Fd
  GOSUB Fd
  GOSUB Fd
  GOSUB Fd
  GOSUB EyeLon
  GOSUB B_turn
  GOSUB Lt
  GOSUB Lt
  GOSUB Lt
  GOSUB Lt

  GOSUB EyesON
  Ado =12
  GOSUB BkAdo

  GOTO start


'-----------------------------------------
'Acts
'----
RockAdo:
  FOR i=1 TO Ado
    GOSUB _rollR
    GOSUB _rollL
   NEXT i
  RETURN

FdAdo:
  FOR i=1 TO Ado
    GOSUB Fd
   NEXT i
  RETURN

BkAdo:
  FOR i=1 TO Ado
    GOSUB Bk
   NEXT i
  RETURN

ToggleEyes:
  TOGGLE eyeLedR_  'alter eyeR so we know program is running
  TOGGLE eyeLedL_  'alter eyeR so we know program is running
  RETURN

EyesON:
  LOW eyeLedR_
  LOW eyeLedL_
  RETURN
EyeRON:
  HIGH eyeLedR_
  LOW eyeLedL_
  RETURN
EyeLON:
  LOW eyeLedR_
  HIGH eyeLedL_
  RETURN

'-----------------------------------------
'Behaviours
'----------
B_fast:
  pacespeed  =6    '6 is about max for servos to keep up
  rollspeed  =3    'half of pacespeed is about right for walking
  RETURN
'B_medium:
'  rollspeed =2
'  pacespeed =3
'  RETURN
'B_slow:
'  rollspeed =1
'  pacespeed =2
'  RETURN
B_turn:
  rollspeed =1  'slow so foot doesn't bounce
  pacespeed =5
  RETURN

'-----------------------------------------
'Actions
'-------
beep150:
  SOUND VoiceLed_,(150,10)
  RETURN

Fd:
SERTXD (" Fd")
  IF paceat<paceC THEN _FdL 'ELSE _FdL
_FdR:
'SERTXD ("_FdR")
  GOSUB _rollL
  GOSUB _RF
  GOSUB Stand
  RETURN
_FdL:
'SERTXD ("_FdL")
  GOSUB _rollR
  GOSUB _LF
  GOSUB Stand
  RETURN


Bk:
SERTXD (" Bk")
  IF paceat<paceC THEN _BkR 'ELSE _BkL
_BkL:
  GOSUB _rollR
  GOSUB _RF
  GOSUB Stand
  RETURN
_BkR:
  GOSUB _rollL
  GOSUB _LF
  GOSUB Stand
  RETURN


Rt:
  IF paceat<paceC THEN GOSUB Fd  'need left foot forward
  GOSUB _RF
  RETURN

Lt:
  IF paceat>paceC THEN GOSUB Fd  'need right foot forward
  GOSUB _LF
  RETURN

_RF:
'SERTXD ("_RF")
  paceto =paceC -paceby
  FOR spulse=paceat TO paceto STEP -pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_LF:
'SERTXD ("_LF")
  paceto =paceC +paceby
  FOR spulse=paceat TO paceto STEP pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

Stand:  'stand with both feet flat
SERTXD (" Sd")
  IF rollat<rollC THEN _StandR 'ELSE _StandL
_StandL:
'SERTXD ("_SL")
  FOR spulse=rollat TO rollC STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_StandR:
'SERTXD ("_SR")
  FOR spulse=rollat TO rollC STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN


_rollL:
'SERTXD ("_rL")
  READ DrollbyL,rollby
  rollto =rollC -rollby
  FOR spulse=rollat TO rollto STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

_rollR:
'SERTXD ("_rR")
  READ DrollbyR,rollby
  rollto =rollC +rollby
  FOR spulse=rollat TO rollto STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

_iStand:                    'initialise with feet in mid position
  FOR i=0 TO 10
    PULSOUT servopace,paceC 'pulse servo paceC
    PULSOUT servoroll,rollC 'pulse servo rollC
    PAUSE 70                'pause 70ms - do it slowly
   NEXT i
  rollat =rollC
  paceat =paceC
  RETURN

pulseservos:
  PULSOUT servoroll,rollat  'pulse servo
  PULSOUT servopace,paceat  'pulse servo
  PAUSE sframe
  RETURN

'=================================================================