'Bambino-23
SERTXD("B23",CR)    'report program number

'684 bytes

#PicAxe 20M2
#no_data

'=================================================================
'PICAXE            IC   Memory   ext  I/O   Outputs  Inputs  ADC  Memory                        Starts  Polled  Resonator
'    Type        pins  bytes    slot pins                        Vars. RAM Spad Data     Table*        Int.    def. opt.
'2.28 PICAXE-20M2  20    2k           18    1-16     1-17     4    28   512      256      512   8       Yes      4   -32

'PICAXE-20M2 circuit board with LEDs off takes 1mA
'PICAXE-20M2 circuit board with LEDs off and servos connected takes 10mA

'=================================================================
'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position
'Bambino-08  Calibrate servo mid positions and put in EEPROM.
'Bambino-08+ Adjust servo mid positions from Handset and put in EEPROM.
'Bambino-09  Introduce _iStand:- initialise with feet in mid position
'Bambino-10  Set rollby, rollbymax for Roll Right
'Bambino-11  Check rollby, rollbymax for Roll Left
'Bambino-12  Check rollby and rollbymax for rollL, rollR
'            save rollbyL and rollbyR in EEPROM
'Bambino-13  Introduction of _Stand
'Bambino-14  Investigate effect of rollspeed;
'            watch roll for all three speeds
'Bambino-15  Investigate effect of rollspeed;
'            watch Roll and Stand for all three speeds
'Bambino-16  Check paceFL paceFR;  Investigate effect of pacespeed
'Bambino-17  Check Fd
'Bambino-18  Test Rt, Lt
'Bambino-19  Test Bk
'Bambino-20  Test T2l: TurntoLight: T2d:  TurntoDark: Wl: Wd:
'Bambino-21  Creaton of sections ACTIONS, BEHAVIOURS, ACTS;
'            Introduction of ACT parameter 'Ado'
'Bambino-22  Demo routine + example use of Start1: to flash eyes
'Bambino-23  Walk Fd with obstacles avoidance using eyes from 04,
'            introduction of Default behaviour

'-----------------------------------------------------------------
Rationale:
'Walk Fd with obstacles avoidance using eyes from 04
'---------------------------------------------------
'Now we can start to make Bambino come alive.
'Bambino reads the two eyes and 
'if there are obstacle sets the bits in the variable obstacles.
'If there is an obstacle to the left it turns on the left eyeLED
'If there is an obstacle to the right it turns on the right eyeLED
'The does Fd,Lt,Rt,Bk depending on the value of obstacles.
'=================================================================
'modified
'--------
'all variable moved up by 2 bytes to leave all the bit variables spare for flags, etc
'start
'Fd  for defaultB
'Bk  for defaultB
'Rt  for defaultB
'Lt  for defaultB


'New
'---
'EyesON:
'EyesOFF:
'f_Bfast  (defaultBehaviour) 1=use default allows Fd, Bk, Rt, Lt to use specific speed settings
'B_turn
'lightL
'lightR
'eyelit
'obsdetectL
'obsdetectR
'QEwhiskerL:    Query Eye whisker Left
'QEwhiskerR:    Query Eye whisker Right

'=================================================================

SYMBOL servopace    =c.0  'left connector
SYMBOL servoroll    =c.4  'right connector
SYMBOL VoiceLed_    =c.5  'low =>LED on
SYMBOL eyeLedL_     =c.2  'low =>LED on
SYMBOL eyeLedR_     =b.1  'low =>LED on
SYMBOL whiskerLedL_ =c.3  'low =>whisker LED on
SYMBOL whiskerLedR_ =b.3  'low =>whisker LED on
SYMBOL eyeR         =c.7
SYMBOL eyeL         =c.1
SYMBOL inIR         =c.6
SYMBOL outIR        =b.2

SYMBOL temp0        =B0
SYMBOL eyelit       =B0
'symbol cmnd         =B1
'b2
SYMBOL B_flags      =B3
SYMBOL  f_Bfast   =bit31 'defaultBehaviour 1=use default
SYMBOL Scentre    =W2
SYMBOL  rollC       =B4  '100 is roll to the left, 200 to the right
SYMBOL  paceC       =B5  '100 is left foot back, 200 left foot forward
SYMBOL Sat        =W3    'current servo positions
SYMBOL  rollat      =B6
SYMBOL  paceat      =B7
SYMBOL Sto        =W4    'desired servo positions
SYMBOL  rollto      =B8
SYMBOL  paceto      =B9
SYMBOL Sspeed     =W5
SYMBOL  rollspeed   =B11 '4 is too fast, 0 won't move
SYMBOL  pacespeed   =B12 '6 is about max for servos to keep up
SYMBOL i            =B13 '_iStand: Acts:
SYMBOL spulse       =b14
SYMBOL eyeRval      =B15
SYMBOL lightL       =B15  'light level Left
SYMBOL eyeLval      =B16
SYMBOL lightR       =B16  'light level Right
SYMBOL eyediff      =B17
SYMBOL Ado          =B18  'parameter for Acts
SYMBOL obstacles    =B19  '%11 bitmap of obstacles  %LeftRight
SYMBOL rollby       =B20 '+ve right 15 good for walking
SYMBOL paceby       =B21 '+ve Left foot forward 20@speed 3; 25@speed 1

SYMBOL rollbymax  =20    '@speed 3; 25@speed 1
'rollmax absolute max is 40, above that the tilt rods hit the body
SYMBOL pacebymax  =30
'pacebymax absolute max is 30, above that the tilt rods hit the rear femur and the horn screws hit the leg body
SYMBOL sframe     =20    'time between servo pulses
'depending on the sensors obsdetectL and obsdetectR may need to be different
SYMBOL obsdetectL   =10  '% light level difference for obstacles
SYMBOL obsdetectR   =10  '% light level difference for obstacles


'EEPROM DATA
SYMBOL DrollbyR =252
SYMBOL DrollbyL =253
SYMBOL DrollC   =254
SYMBOL DpaceC   =255
'=================================================================
initialise:
  rollC =150  'Default, 100 is roll to the left, 150 is nominal centre
  paceC =150  'Default, 100 is left foot back,   150 is nominal centre
  'get values from EEPROM if set by program #8 or #8+
  READ DrollC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    rollC =temp0
   ELSE
    WRITE DrollC,rollC             'save default for other programs
   ENDIF
  READ DpaceC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    paceC =temp0
   ELSE
    WRITE DpaceC,paceC             'save default  for other programs
   ENDIF
  SERTXD("rollC=",#rollC," paceC=",#PAceC,CR)
  SERTXD("roll=",#rollat," pace=",#pACeat,CR)

  LOW eyeLedR_     'make output
  HIGH eyeLedL_    'make output
  GOSUB _iStand    'stand and initialise rollat, paceat

  'rollby     =15    '15 good for walking, read FROM eeprom
  paceby     =28

initspeed:
  GOSUB B_fast


start:
  obstacles =0
  GOSUB EyesOFF
QEwhiskerL:
  READADC eyeL,lightL
  LOW eyeLedL_              'eyeL on
  PAUSE 1
  READADC eyeL,eyelit
  HIGH  eyeLedL_            'eyeL off
  eyelit =eyelit MIN lightL 'shouldn't be darker with LED on
  eyelit =eyelit MIN 1      'if temp=0 then temp=255 which is wrong
  eyelit =eyelit -lightL *100 /eyelit 'find difference as %
  SERTXD(" L=",#eyelit," ")
  IF eyelit<obsdetectL THEN QEwhiskerR  'ignore
  obstacles =obstacles OR %10

QEwhiskerR:
  READADC eyeR,lightR
  LOW eyeLedR_              'eyeR on
  PAUSE 1
  READADC eyeR,eyelit
  HIGH  eyeLedR_            'eyeR off
  eyelit =eyelit MIN lightR 'shouldn't be darker with LED on
  eyelit =eyelit MIN 1      'if temp=0 then temp=255 which is wrong
  eyelit =eyelit -lightR *100 /eyelit 'find difference as %
  SERTXD("R=",#TEmp0,CR)
  IF eyelit<obsdetectR THEN Walk  'ignore
  obstacles =obstacles OR 1


Walk:
  temp0 =obstacles     'to use bits
  IF BIT0=1 THEN
    LOW eyeLedR_       'default state is high => off
   ENDIF
  IF BIT1=1 THEN
    LOW eyeLedL_       'default state is high => off
   ENDIF
  '                  00 10 01 11
  ON obstacles GOSUB Fd,Lt,Rt,Bk
  GOTO start           'loop back to start

'-----------------------------------------
'Acts
'----

RockAdo:
  FOR i=1 TO Ado
    GOSUB _rollR
    GOSUB _rollL
   NEXT i
  RETURN

FdAdo:
  FOR i=1 TO Ado
    GOSUB Fd
   NEXT i
  RETURN

BkAdo:
  FOR i=1 TO Ado
    GOSUB Bk
   NEXT i
  RETURN

'-----------------------------------------
'Behaviours
'----------
B_fast:
  pacespeed  =6    '6 is about max for servos to keep up
  rollspeed  =3    'half of pacespeed is about right for walking
  f_Bfast =1
  RETURN
'B_medium:
'  rollspeed =2
'  pacespeed =3
'  RETURN
'B_slow:
'  rollspeed =1
'  pacespeed =2
'  RETURN
B_turn:
  rollspeed =1  'slow so foot doesn't bounce
  pacespeed =5
  RETURN
'-----------------------------------------
'Actions
'-------

beep150:
  SOUND VoiceLed_,(150,10)
  RETURN

EyesOFF:
  HIGH eyeLedR_
  HIGH eyeLedL_
  RETURN

EyesON:
  LOW eyeLedR_
  LOW eyeLedL_
  RETURN


Fd:
SERTXD (" Fd")
  IF f_Bfast=1 THEN GOSUB B_fast
  IF paceat<paceC THEN _FdL 'ELSE _FdL
_FdR:
'SERTXD ("_FdR")
  GOSUB _rollL
  GOSUB _RF
  GOSUB Stand
  RETURN
_FdL:
'SERTXD ("_FdL")
  GOSUB _rollR
  GOSUB _LF
  GOSUB Stand
  RETURN


Bk:
SERTXD (" Bk")
  IF f_Bfast=1 THEN GOSUB B_fast
  IF paceat<paceC THEN _BkR 'ELSE _BkL
_BkL:
  GOSUB _rollR
  GOSUB _RF
  GOSUB Stand
  RETURN
_BkR:
  GOSUB _rollL
  GOSUB _LF
  GOSUB Stand
  RETURN


Rt:
SERTXD (" Rt")
  IF paceat<paceC THEN GOSUB Fd  'need left foot forward
  IF f_Bfast=1 THEN GOSUB beep150
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _RF
  RETURN

Lt:
SERTXD (" Lt")
  IF paceat>paceC THEN GOSUB Fd  'need right foot forward
  IF f_Bfast=1 THEN GOSUB beep150
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _LF
  RETURN

_RF:
'SERTXD ("_RF")
  paceto =paceC -paceby
  FOR spulse=paceat TO paceto STEP -pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_LF:
'SERTXD ("_LF")
  paceto =paceC +paceby
  FOR spulse=paceat TO paceto STEP pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN


Stand:  'stand with both feet flat
SERTXD (" Sd")
  IF rollat<rollC THEN _StandR 'ELSE _StandL
_StandL:
'SERTXD ("_SL")
  FOR spulse=rollat TO rollC STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_StandR:
'SERTXD ("_SR")
  FOR spulse=rollat TO rollC STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN


_rollL:
'SERTXD ("_rL")
  READ DrollbyL,rollby
  rollto =rollC -rollby
  FOR spulse=rollat TO rollto STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

_rollR:
'SERTXD ("_rR")
  READ DrollbyR,rollby
  rollto =rollC +rollby
  FOR Spulse=rollat TO rollto STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

_iStand:
'initialise with feet in mid position
  FOR i=0 TO 10
    PULSOUT servopace,paceC  'pulse servo paceC
    PULSOUT servoroll,rollC  'pulse servo rollC
    PAUSE 70        'pause 70ms - do it slowly
   NEXT i
  rollat =rollC
  paceat =paceC
  RETURN

pulseservos:
  PULSOUT servoroll,rollat  'pulse servo
  PULSOUT servopace,paceat  'pulse servo
  PAUSE sframe
  RETURN

'=================================================================