'Bambino-24
SERTXD("B24",CR)    'report program number

'698 bytes

#PicAxe 20M2
#no_data

'=================================================================
'PICAXE            IC   Memory   ext  I/O   Outputs  Inputs  ADC  Memory                        Starts  Polled  Resonator
'    Type        pins  bytes    slot pins                        Vars. RAM Spad Data     Table*        Int.    def. opt.
'2.28 PICAXE-20M2  20    2k           18    1-16     1-17     4    28   512      256      512   8       Yes      4   -32

'PICAXE-20M2 circuit board with LEDs off takes 1mA
'PICAXE-20M2 circuit board with LEDs off and servos connected takes 10mA

'=================================================================
'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position
'Bambino-08  Calibrate servo mid positions and put in EEPROM.
'Bambino-08+ Adjust servo mid positions from Handset and put in EEPROM.
'Bambino-09  Introduce _iStand:- initialise with feet in mid position
'Bambino-10  Set rollby, rollbymax for Roll Right
'Bambino-11  Check rollby, rollbymax for Roll Left
'Bambino-12  Check rollby and rollbymax for rollL, rollR
'            save rollbyL and rollbyR in EEPROM
'Bambino-13  Introduction of _Stand
'Bambino-14  Investigate effect of rollspeed;
'            watch roll for all three speeds
'Bambino-15  Investigate effect of rollspeed;
'            watch Roll and Stand for all three speeds
'Bambino-16  Check paceFL paceFR;  Investigate effect of pacespeed
'Bambino-17  Check Fd
'Bambino-18  Test Rt, Lt
'Bambino-19  Test Bk
'Bambino-20  Test T2l: TurntoLight: T2d:  TurntoDark: Wl: Wd:
'Bambino-21  Creaton of sections ACTIONS, BEHAVIOURS, ACTS;
'            Introduction of ACT parameter 'Ado'
'Bambino-22  Demo routine + example use of Start1: to flash eyes
'Bambino-23  Walk Fd with obstacles avoidance using eyes from 04,
'            introduction of Default behaviour
'Bambino-24  Walk Fd with obstacles avoidance as 23, with Act BT

'-----------------------------------------------------------------
Rationale:
'Walk Fd with obstacles avoidance using eyes from 04
'--------------------------------------------------
'Simply stepping backwards if there are obstacles to the right and left
'as in #23 is not very useful, 
'here is introduced BT which steps back twice and then turns.
'=================================================================
'modified
'--------
'Walk: BT instead of Bk

'New
'---
'BT   Back Back and Turn right

'=================================================================
SYMBOL servopace    =c.0  'left connector
SYMBOL servoroll    =c.4  'right connector
SYMBOL VoiceLed_    =c.5  'low =>LED on
SYMBOL eyeLedL_     =c.2  'low =>LED on
SYMBOL eyeLedR_     =b.1  'low =>LED on
SYMBOL whiskerLedL_ =c.3  'low =>whisker LED on
SYMBOL whiskerLedR_ =b.3  'low =>whisker LED on
SYMBOL eyeR         =c.7
SYMBOL eyeL         =c.1
SYMBOL inIR         =c.6
SYMBOL outIR        =b.2

SYMBOL temp0        =B0
SYMBOL eyelit       =B0
'symbol cmnd         =B1
'b2
SYMBOL B_flags      =B3
SYMBOL  f_Bfast      =bit31 'speed Behaviour 1=use B_fast:
SYMBOL Scentre    =W2
SYMBOL  rollC       =B4  '100 is roll to the left, 200 to the right
SYMBOL  paceC       =B5  '100 is left foot back, 200 left foot forward
SYMBOL Sat        =W3    'current servo positions
SYMBOL  rollat      =B6
SYMBOL  paceat      =B7
SYMBOL Sto        =W4    'desired servo positions
SYMBOL  rollto      =B8
SYMBOL  paceto      =B9
SYMBOL Sspeed     =W5
SYMBOL  rollspeed   =B11 '4 is too fast, 0 won't move
SYMBOL  pacespeed   =B12 '6 is about max for servos to keep up
SYMBOL i            =B13 '_iStand: Acts:
SYMBOL spulse       =B14
SYMBOL eyeRval      =B15
SYMBOL lightL       =B15  'light level Left
SYMBOL eyeLval      =B16
SYMBOL lightR       =B16  'light level Right
SYMBOL eyediff      =B17
SYMBOL Ado          =B18  'parameter for Acts
SYMBOL obstacles    =B19  '%11 bitmap of obstacles  %LeftRight
SYMBOL rollby       =B20 '+ve right 15 good for walking
SYMBOL paceby       =B21 '+ve Left foot forward 20@speed 3; 25@speed 1

SYMBOL rollbymax  =20    '@speed 3; 25@speed 1
'rollmax absolute max is 40, above that the tilt rods hit the body
SYMBOL pacebymax  =30
'pacebymax absolute max is 30, above that the tilt rods hit the rear femur and the horn screws hit the leg body
SYMBOL sframe     =20    'time between servo pulses
'depending on the sensors obsdetectL and obsdetectR may need to be different
SYMBOL obsdetectL   =10  '% light level difference for obstacles
SYMBOL obsdetectR   =10  '% light level difference for obstacles


'EEPROM DATA
SYMBOL DrollbyR =252
SYMBOL DrollbyL =253
SYMBOL DrollC   =254
SYMBOL DpaceC   =255

'=================================================================
initialise:
  rollC =150  'Default, 100 is roll to the left, 150 is nominal centre
  paceC =150  'Default, 100 is left foot back,   150 is nominal centre
  'get values from EEPROM if set by program #8 or #8+
  READ DrollC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    rollC =temp0
   ELSE
    WRITE DrollC,rollC             'save default for other programs
   ENDIF
  READ DpaceC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    paceC =temp0
   ELSE
    WRITE DpaceC,paceC             'save default  for other programs
   ENDIF
  SERTXD("rollC=",#rollC," paceC=",#paceC,CR)
  SERTXD("roll=",#rollat," pace=",#paceat,CR)

  LOW eyeLedR_     'make output
  HIGH eyeLedL_    'make output
  GOSUB _iStand    'stand and initialise rollat, paceat

  'rollby     =15    '15 good for walking, READ from EEPROM
  paceby     =28

initspeed:
  GOSUB B_fast

START:
  obstacles =0
  GOSUB EyesOFF
QEwhiskerL:
  READADC eyeL,lightL
  LOW eyeLedL_              'eyeL on
  PAUSE 1
  READADC eyeL,eyelit
  HIGH  eyeLedL_            'eyeL off
  eyelit =eyelit MIN lightL 'shouldn't be darker with LED on
  eyelit =eyelit MIN 1  'if eyelit=0 then eyelit=255 which is wrong
  eyelit =eyelit -lightL *100 /eyelit 'find difference as %
  SERTXD(" L=",#eyelit," ")
  IF eyelit<obsdetectL THEN QEwhiskerR  'ignore
  obstacles =obstacles OR %10

QEwhiskerR:
  READADC eyeR,lightR
  LOW eyeLedR_              'eyeR on
  PAUSE 1
  READADC eyeR,eyelit
  HIGH  eyeLedR_            'eyeR off
  eyelit =eyelit MIN lightR 'shouldn't be darker with LED on
  eyelit =eyelit MIN 1      'if temp=0 then temp=255 which is wrong
  eyelit =eyelit -lightR *100 /eyelit 'find difference as %
  SERTXD("R=",#temp0,CR)
  IF eyelit<obsdetectR THEN Walk  'ignore
  obstacles =obstacles OR 1


Walk:
  temp0 =obstacles     'to use bits
  IF BIT0=1 THEN
    LOW eyeLedR_       'default state is high => off
   ENDIF
  IF BIT1=1 THEN
    LOW eyeLedL_       'default state is high => off
   ENDIF
  ON obstacles GOSUB Fd,Lt,Rt,BT
  GOTO START           'loop back to start

'-----------------------------------------
'Acts
'----

RockAdo:
  FOR i=1 TO Ado
    GOSUB _rollR
    GOSUB _rollL
   NEXT i
  RETURN

FdAdo:
  FOR i=1 TO Ado
    GOSUB Fd
   NEXT i
  RETURN

BkAdo:
  FOR i=1 TO Ado
    GOSUB Bk
   NEXT i
  RETURN

BT:
  GOSUB Bk
  GOSUB Bk
  GOSUB Rt
  RETURN

'-----------------------------------------
'Behaviours
'----------
B_fast:
  pacespeed  =6    '6 is about max for servos to keep up
  rollspeed  =3    'half of pacespeed is about right for walking
  f_Bfast =1
  RETURN
'B_medium:
'  rollspeed =2
'  pacespeed =3
'  RETURN
'B_slow:
'  rollspeed =1
'  pacespeed =2
'  RETURN
B_turn:
  rollspeed =1  'slow so foot doesn't bounce
  pacespeed =5
  RETURN

'-----------------------------------------
'Actions
'-------

beep150:
  SOUND VoiceLed_,(150,10)
  return

EyesOFF:
  high eyeLedR_
  high eyeLedL_
  return

EyesON:
  low eyeLedR_
  low eyeLedL_
  return


Fd:
SERTXD (" Fd")
  if f_Bfast=1 then gosub B_fast
  if paceat<paceC then _FdL 'else _FdL
_FdR:
'SERTXD ("_FdR")
  gosub _rollL
  gosub _RF
  gosub Stand
  return
_FdL:
'SERTXD ("_FdL")
  gosub _rollR
  gosub _LF
  gosub Stand
  return


Bk:
SERTXD (" Bk")
  if f_Bfast=1 then gosub B_fast
  if paceat<paceC then _BkR 'else _BkL
_BkL:
  gosub _rollR
  gosub _RF
  gosub Stand
  return
_BkR:
  gosub _rollL
  gosub _LF
  gosub Stand
  return


Rt:
SERTXD (" Rt")
  IF paceat<paceC THEN GOSUB Fd  'need left foot forward
  IF f_Bfast=1 THEN GOSUB beep150
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _RF
  RETURN

Lt:
SERTXD (" Lt")
  IF paceat>paceC THEN GOSUB Fd  'need right foot forward
  IF f_Bfast=1 THEN GOSUB beep150
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _LF
  RETURN

_RF:
'SERTXD ("_RF")
  paceto =paceC -paceby
  FOR spulse=paceat TO paceto STEP -pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_LF:
'SERTXD ("_LF")
  paceto =paceC +paceby
  FOR spulse=paceat TO paceto STEP pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN


Stand:  'stand with both feet flat
SERTXD (" Sd")
  IF rollat<rollC THEN _StandR 'else _StandL
_StandL:
'SERTXD ("_SL")
  FOR spulse=rollat TO rollC STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_StandR:
'SERTXD ("_SR")
  FOR spulse=rollat TO rollC STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN


_rollL:
'SERTXD ("_rL")
  READ DrollbyL,rollby
  rollto =rollC -rollby
  FOR spulse=rollat TO rollto STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

_rollR:
'SERTXD ("_rR")
  READ DrollbyR,rollby
  rollto =rollC +rollby
  FOR Spulse=rollat TO rollto STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

_iStand:
'initialise with feet in mid position
  FOR i=0 TO 10
    PULSOUT servopace,paceC  'pulse servo paceC
    PULSOUT servoroll,rollC  'pulse servo rollC
    PAUSE 70        'pause 70ms - do it slowly
   NEXT i
  rollat =rollC
  paceat =paceC
  RETURN

pulseservos:
  PULSOUT servoroll,rollat  'pulse servo
  PULSOUT servopace,paceat  'pulse servo
  PAUSE sframe
  RETURN

'=================================================================
