'Bambino-31
SERTXD("B31",CR)    'report program number @4800

'1265 bytes

#PicAxe 20M2
#no_data
'=================================================================
'PICAXE            IC   Memory   ext  I/O   Outputs  Inputs  ADC  Memory                        Starts  Polled  Resonator
'    Type        pins  bytes    slot pins                        Vars. RAM Spad Data     Table*        Int.    def. opt.
'2.28 PICAXE-20M2  20    2k           18    1-16     1-17     4    28   512      256      512   8       Yes      4   -32

'PICAXE-20M2 circuit board with LEDs off takes 1mA
'PICAXE-20M2 circuit board with LEDs off and servos connected takes 10mA
'=================================================================

'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position
'Bambino-08  Calibrate servo mid positions and put in EEPROM.
'Bambino-08+ Adjust servo mid positions from Handset and put in EEPROM.
'Bambino-09  Introduce _iStand:- initialise with feet in mid position
'Bambino-10  Set rollby, rollbymax for Roll Right
'Bambino-11  Check rollby, rollbymax for Roll Left
'Bambino-12  Check rollby and rollbymax for rollL, rollR
'            save rollbyL and rollbyR in EEPROM
'Bambino-13  Introduction of _Stand
'Bambino-14  Investigate effect of rollspeed;
'            watch roll for all three speeds
'Bambino-15  Investigate effect of rollspeed;
'            watch Roll and Stand for all three speeds
'Bambino-16  Check paceFL paceFR;  Investigate effect of pacespeed
'Bambino-17  Check Fd
'Bambino-18  Test Rt, Lt
'Bambino-19  Test Bk
'Bambino-20  Test T2l: TurntoLight: T2d:  TurntoDark: Wl: Wd:
'Bambino-21  Creaton of sections ACTIONS, BEHAVIOURS, ACTS;
'            Introduction of ACT parameter 'Ado'
'Bambino-22  Demo routine + example use of Start1: to flash eyes
'Bambino-23  Walk Fd with obstacles avoidance using eyes from 04,
'            introduction of Default behaviour
'Bambino-24  Walk Fd with obstacles avoidance as 23, with Act BT
'Bambino-25  Walk Fd with drop-off avoidance using whiskers from 05
'Bambino-26  rewritten with reading of whiskers as subroutines
'Bambino-27  rewritten with autocalibration of down whiskers
'Bambino-28  Test maximum PWM and hence minimum brightness of eyeLEDs,
'            needed in Bambino-29
'Bambino-29  Wait for IR command then do it otherwise WANDER as B24
'Bambino-30  rewrite to clearer code
'Bambino-31  remember a sequence of key presses on IR-controller

'-----------------------------------------------------------------
Rationale:
'The program can now record infra-red commands into RAM and replay
'them
'Press [|] to start recording
'Press [POWER] or [1] to end recording
'Press [1] to play recording
'RockAdo is moved to key [2]  it can be included in remembered moves.
'=================================================================
'modified
'--------

'New
'---
'be able to record some moves and replay them using Key [1]
'Press [|] to start recording
'Press [POWER] or [1] to end recording
'Press [1] to play recording
'RockAdo is moved to key [2]  it can be included in remembered moves.
'=================================================================
'TVR010 PicAxe IR-controller
'---------------------------
'Before use, the transmitter must be programmed with the Sony transmit code.
'1. Insert 2 AAA size batteries, preferably alkaline.
'2. Press S and B at the same time. S is in the centre of the arrows.
'  The top left red LED should light.
'3. Press 0. The LED should flash.
'4. Press 1. The LED should flash.
'5. Press 3. The LED should go out.
'6. Press the red power button (top right).
'-------------------------------------------
'IRIN cmnds PicAxe controller
'DO NOT PRESS OTHER KEYS
'ie [A] [B] [C] [D] [E] [F] [G]
'They change the Mode and [B] has to be pressed to change back.
'[square] [triangle] [()] [L] [X] [backwards F]  have no effect

SYMBOL KEY_POWER  = 21    'Sleep

SYMBOL KEY_UP     = 16    'Step Forward
SYMBOL KEY_DOWN   = 17    'Step Backward
SYMBOL KEY_RIGHT  = 18    'Turn Right
SYMBOL KEY_LEFT   = 19    'Turn Left

SYMBOL KEY_BAR    = 96
SYMBOL KEY_TENT   = 54
SYMBOL KEY_VERT_CROSS = 37
SYMBOL KEY_VCROSS = 37    'synonym for easier coding
SYMBOL KEY_DIAG_CROSS = 20
SYMBOL KEY_XCROSS = 20    'synonym for easier coding
SYMBOL IRkey1     =  0
SYMBOL IRkey2     =  1
SYMBOL IRkey3     =  2
SYMBOL IRkey4     =  3
SYMBOL IRkey5     =  4
SYMBOL IRkey6     =  5
SYMBOL IRkey7     =  6
SYMBOL IRkey8     =  7
SYMBOL IRkey9     =  8
SYMBOL KEY_MINUS  = 98
SYMBOL KEY_0      =  9    'Quit command mode
SYMBOL KEY_PLUS   = 11
'=================================================================

SYMBOL servopace    =c.0  'left connector
SYMBOL servoroll    =c.4  'right connector
SYMBOL VoiceLed_    =c.5  'low =>LED on
SYMBOL eyeLedL_     =c.2  'low =>LED on
SYMBOL eyeLedR_     =b.1  'low =>LED on
SYMBOL whiskerLedL_ =c.3  'low =>whisker LED on
SYMBOL whiskerLedR_ =b.3  'low =>whisker LED on
SYMBOL eyeR         =c.7  'adc
SYMBOL eyeL         =c.1  'adc
SYMBOL whiskerL     =b.5  'adc whisker Down Left
SYMBOL whiskerR     =b.0  'adc whisker Down Right
SYMBOL inIR         =c.6
SYMBOL outIR        =b.2

SYMBOL tempW0     =W0
SYMBOL  temp0       =B0   'initialise: walk:
SYMBOL  eyelit      =B0   'QEwhiskerX
SYMBOL  whisklit    =B1   'QGwhiskerX
'SYMBOL tempW1     =W1
SYMBOL cmnd         =B2
SYMBOL IRcmnd       =B2   'cmnd from IRremote
SYMBOL B_flags      =B3
'SYMBOL f_doIRcmnds
SYMBOL  f_play       =bit28 '1=playing
SYMBOL  f_record     =bit29 '1=recording
SYMBOL  f_direction  =bit30 'currrent direction Fd=1, Bk=0
SYMBOL  f_Bfast      =bit31 'speed Behaviour 1=use B_fast:
SYMBOL Scentre    =W2
SYMBOL  rollC       =B4  '100 is roll to the left, 200 to the right
SYMBOL  paceC       =B5  '100 is left foot back, 200 left foot forward
SYMBOL Sat        =W3    'current servo positions
SYMBOL  rollat      =B6
SYMBOL  paceat      =B7
SYMBOL Sto        =W4    'desired servo positions
SYMBOL  rollto      =B8
SYMBOL  paceto      =B9
SYMBOL Sspeed     =W5
SYMBOL  rollspeed   =B10 '4 is too fast, 0 won't move
SYMBOL  pacespeed   =B11 '6 is about max for servos to keep up
SYMBOL Smoveby    =W6
SYMBOL  rollby      =B12 '+ve right 15 good for walking
SYMBOL  paceby      =B13 '+ve Left foot forward 20@speed 3; 25@speed 1
SYMBOL Light      =W7
SYMBOL  lightR      =B14 'light level Right
SYMBOL  lightL      =B15 'light level Left
SYMBOL i            =B16 '_iStand:
SYMBOL spulse       =B16 'FOR NEXT counter for servo pulses
SYMBOL Ado          =B17 'parameter for Acts
SYMBOL iA           =B18 'counter for Acts
SYMBOL obstacles    =B19 '%11 bitmap of obstacles  %LeftRight

SYMBOL rollbymax  =20   'rollmax absolute max is 40,
                        'above that the tilt rods hit the body
                        '@speed 3; 25@speed 1
SYMBOL pacebymax  =30   'pacebymax absolute max is 30,
                        'above that the tilt rods hit the rear femur
                        'and the horn screws hit the leg body
SYMBOL sframe     =20   'time between servo pulses
  'depending on the sensors obsdetectL and obsdetectR may need to be different
SYMBOL obsdetectL   =10 '% light level difference for obstacle
SYMBOL obsdetectR   =10 '% light level difference for obstacle
  'depending on the sensors holedetectL and holedetectR may need to be different
  'If there is close tungsten light then Bambino may need an eye shade or a neb to shield the ground from the tungsten light.
SYMBOL holedetectL=2    'light level difference for holes
SYMBOL holedetectR=2    'light level difference for holes
  'edit holedetect values so Bambino can see table edges
  'whisker LEDs on, 82R 1.414v =>17.2mA @4.02V

'EEPROM DATA
SYMBOL DholedetectR =250   'content 60% of ambient lightR
SYMBOL DholedetectL =251   'content 60% of ambient lightL
SYMBOL DrollbyR     =252
SYMBOL DrollbyL     =253
SYMBOL DrollC       =254
SYMBOL DpaceC       =255

'=================================================================
INITIALISE:
init_rollCpaceC:
  rollC =150  'Default, 100 is roll to the left, 150 is nominal centre
  paceC =150  'Default, 100 is left foot back,   150 is nominal centre
  'get values from EEPROM if set by program #8 or #8+
  READ DrollC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    rollC =temp0
   ELSE
    WRITE DrollC,rollC             'save default for other programs
   ENDIF
  READ DpaceC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    paceC =temp0
   ELSE
    WRITE DpaceC,paceC             'save default  for other programs
   ENDIF
  SERTXD("rollC=",#rollC," paceC=",#paceC,CR)

  HIGH eyeLedR_    'make output and OFF
  HIGH eyeLedL_    'make output and OFF
  GOSUB _iStand    'stand and initialise rollat, paceat

  'rollby     =15   '+ve right good for walking, READ from EEPROM
  paceby     =25   '+ve Left  foot forward

initmind:
  GOSUB B_fast
  f_record =0
  bptr     =32
  POKE bptr,0    'no recording

  GOSUB beep150    'so we know Bambino started, leaves VoiceLED on

START:
SERTXD("S")
  Ado =4        'for RockAdo
  IRIN [50,WANDER],inIR,IRcmnd  'IRIN with timeout, no IR =>WANDER
  GOSUB beep50                  'so we know IR received
  GOTO IRacty
'=================================================================
Activities:

IRacty:
  SERTXD("IR")
DoIRcmnd:
  SERTXD(#IRcmnd)
  SERTXD("f_play",#f_play,"f_rec",#f_record)
  SERTXD("@",#bptr,"=",#IRcmnd)
  SELECT IRcmnd
    CASE KEY_POWER
      IF f_record=1 THEN
        f_record =0
        @bptr =0          'end marker
       ELSE
        GOSUB rest
        GOSUB EyesON
        GOTO DoIRcmnd    'have already got IRcmnd in rest:
       ENDIF
    CASE KEY_UP
      IF f_record=1 THEN
        @bptrinc =IRcmnd
       ENDIF
      GOSUB Fd
    CASE KEY_DOWN
      IF f_record=1 THEN
        @bptrinc =IRcmnd
       ENDIF
      GOSUB Bk
    CASE KEY_RIGHT
      IF f_record=1 THEN
        @bptrinc =IRcmnd
       ENDIF
      GOSUB Rt
    CASE KEY_LEFT
      IF f_record=1 THEN
        @bptrinc =IRcmnd
       ENDIF
      GOSUB Lt
    CASE IRkey1
      f_play =1      'play
      bptr =32       'set to start
      SERTXD("bptr",#bptr)
    CASE IRkey2
      IF f_record=1 THEN
        @bptrinc =IRcmnd
       ENDIF
      GOSUB RockAdo
    CASE KEY_0
      GOTO Start      'QUIT
    CASE KEY_BAR
      f_record =1
      f_play =0
      bptr =32        'set to start
   END SELECT

  IF f_play=1 THEN
    f_record =0
    IRcmnd =@bptrinc  'read remembered command
    IF IRcmnd=0 THEN  '0=end
      f_play =0
      IRcmnd =255     'not valid IRcmnd
     ENDIF
    GOTO  DoIRcmnd
   ENDIF

GetIR:
  IF f_record=1 THEN
    LOW VoiceLed_     'turn on mouth while waiting
   ELSE
    HIGH VoiceLed_    'turn off mouth while waiting
   ENDIF
  IRIN inIR,IRcmnd    'Get IRcmnd
  GOSUB beep50        'so we know IR received
  GOTO DoIRcmnd       'Do code


'-----------------------------------------
WANDER:
SERTXD("W")
  obstacles =0
  GOSUB EyesOFF

QEwhiskerL:
  READADC eyeL,lightL
  LOW eyeLedL_              'eyeL on
  PAUSE 1
  READADC eyeL,eyelit
  HIGH  eyeLedL_            'eyeL off
  eyelit =eyelit MIN lightL 'shouldn't be darker with LED on
  eyelit =eyelit MIN 1  'if eyelit=0 then eyelit=255 which is wrong
  eyelit =eyelit -lightL *100 /eyelit 'find difference as %
  SERTXD(" L=",#eyelit," ")
  IF eyelit<obsdetectL THEN QEwhiskerR  'ignore
  obstacles =obstacles OR %10

QEwhiskerR:
  READADC eyeR,lightR
  LOW eyeLedR_              'eyeR on
  PAUSE 1
  READADC eyeR,eyelit
  HIGH  eyeLedR_            'eyeR off
  eyelit =eyelit MIN lightR 'shouldn't be darker with LED on
  eyelit =eyelit MIN 1      'if temp=0 then temp=255 which is wrong
  eyelit =eyelit -lightR *100 /eyelit 'find difference as %
  SERTXD("R=",#temp0,CR)
  IF eyelit<obsdetectR THEN Walk  'ignore
  obstacles =obstacles OR 1

Walk:
  temp0 =obstacles     'to use bits
  IF BIT0=1 THEN
    LOW eyeLedR_       'default state is high => off
   ENDIF
  IF BIT1=1 THEN
    LOW eyeLedL_       'default state is high => off
   ENDIF
  ON obstacles GOSUB Fd,Lt,Rt,BT
  GOTO START           'loop back to start for unknown
'=================================================================
Behaviours:

B_fast:
  pacespeed  =6    '6 is about max for servos to keep up
  rollspeed  =3    'half of pacespeed is about right for walking
  f_Bfast =1
  RETURN
'B_medium:
'  rollspeed =2
'  pacespeed =3
'  RETURN
'B_slow:
'  rollspeed =1
'  pacespeed =1
'  RETURN
B_turn:
  rollspeed =1  'slow so foot doesn't bounce
  pacespeed =5
  RETURN
'=================================================================
ProgramActs:
'----------

RockAdo:
  IF f_Bfast=1 THEN GOSUB B_fast
  FOR iA=1 TO Ado
    GOSUB _rollR
    GOSUB _rollL
   NEXT iA
  GOSUB Stand
  RETURN

FdAdo:
  FOR iA=1 TO Ado
    GOSUB Fd
   NEXT iA
  RETURN

BkAdo:
  FOR iA=1 TO Ado
    GOSUB Bk
   NEXT iA
  RETURN

BT:
  GOSUB Bk
  GOSUB Bk
  GOSUB Rt
  GOSUB Rt
  RETURN

Rest:
  GOSUB _rollL
  GOSUB _iStand
  GOSUB EyesDimmest
  HIGH whiskerLedL_
  HIGH whiskerLedR_
  HIGH VoiceLed_    'LED off
_RestIRin:
  IRIN inIR,cmnd    'IRIN with no timeout
  GOSUB EyesOFF
  RETURN
'=================================================================
Actions:
'-------

Fd:
SERTXD ("Fd")
  f_direction =1
  IF f_Bfast=1 THEN GOSUB B_fast
  IF paceat<paceC THEN _FdL 'else _FdR
_FdR:
'SERTXD ("_FdR")
  GOSUB _rollL
  GOSUB _RF
  GOSUB Stand
  RETURN
_FdL:
'SERTXD ("_FdL")
  GOSUB _rollR
  GOSUB _LF
  GOSUB Stand
  RETURN
'-----------------------------------------
Bk:
SERTXD ("Bk")
  f_direction =0
  IF f_Bfast=1 THEN GOSUB B_fast
  IF paceat<paceC THEN _BkR 'else _BkL
_BkL:
  GOSUB _rollR
  GOSUB _RF
  GOSUB Stand
  RETURN
_BkR:
  GOSUB _rollL
  GOSUB _LF
  GOSUB Stand
  RETURN
'-----------------------------------------
Rt:
SERTXD ("Rt")
  IF paceat<paceC AND f_direction=1 THEN GOSUB Fd  'need left foot forward
  IF paceat<paceC AND f_direction=0 THEN GOSUB Bk  'need left foot forward
  IF f_Bfast=1 THEN GOSUB beep150
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _RF
  RETURN
'-----------------------------------------
Lt:
SERTXD ("Lt")
  IF paceat>paceC AND f_direction=1 THEN GOSUB Fd  'need right foot forward
  IF paceat>paceC AND f_direction=0 THEN GOSUB Bk  'need right foot forward
  IF f_Bfast=1 THEN GOSUB beep150
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _LF
  RETURN
'=================================================================
_RF:
'SERTXD ("_RF")
  paceto =paceC -paceby
  FOR spulse=paceat TO paceto STEP -pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_LF:
'SERTXD ("_LF")
  paceto =paceC +paceby
  FOR spulse=paceat TO paceto STEP pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
'-----------------------------------------
Stand:  'stand with both feet flat
'SERTXD (" Sd")
  IF rollat<rollC THEN _StandR 'else _StandL
_StandL:
'SERTXD ("_SL")
  FOR spulse=rollat TO rollC STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_StandR:
'SERTXD ("_SR")
  FOR spulse=rollat TO rollC STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
'-----------------------------------------
_rollL:
'SERTXD ("_rL")
  READ DrollbyL,rollby
  rollto =rollC -rollby
  FOR spulse=rollat TO rollto STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

_rollR:
'SERTXD ("_rR")
  READ DrollbyR,rollby
  rollto =rollC +rollby
  FOR Spulse=rollat TO rollto STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
'-----------------------------------------
pulseservos:
  PULSOUT servoroll,rollat  'pulse servo
  PULSOUT servopace,paceat  'pulse servo
  PAUSE sframe
  RETURN
'-----------------------------------------
_iStand:
  'initialise with feet in mid position
  FOR i=0 TO 10
    PULSOUT servopace,paceC  'pulse servo paceC
    PULSOUT servoroll,rollC  'pulse servo rollC
    PAUSE 70        'pause 70ms - do it slowly
   NEXT i
  rollat =rollC
  paceat =paceC
  RETURN
'-----------------------------------------
beep50:
  SOUND VoiceLed_,(50,10)  'this leaves mouthLED ON
  HIGH VoiceLed_      'turn off mouth
  RETURN

beep150:
  SOUND VoiceLed_,(150,10)  'this leaves mouthLED ON
  HIGH VoiceLed_      'turn off mouth
  RETURN

EyesOFF:
  PWMOUT eyeLedR_,off
  PWMOUT eyeLedL_,off
  HIGH eyeLedR_         'LED off
  HIGH eyeLedL_         'LED off
  RETURN

EyesON:
  LOW eyeLedR_
  LOW eyeLedL_
  RETURN

EyesDimmest:
  pwmout eyeLedR_,255,1023 'active low so high Dutycycle for dim,
  pwmout eyeLedL_,255,1023 'active low so high Dutycycle for dim,
  RETURN

'=================================================================
Sense:

calibrateholewhiskers:
  Light =0  'clear temp Hi Lo
'take averages of 8 readings per whisker
  LOW whiskerLedL_        'eyeL on
  FOR i=0 TO 7
    READADC whiskerL,temp0
    SERTXD("L",#temp0)
    temp0 =temp0 /8
    lightL =lightL +temp0
    SERTXD(" ",#lightL,CR)
    NEXT i
  HIGH whiskerLedL_       'eyeL off
  LOW WhiskerLedR_        'eyeR on
  FOR I=0 TO 7
    READADC whiskerR,temp0
    SERTXD("R",#temp0)
    temp0 =temp0 /8
    lightR =lightR +temp0
    SERTXD(" ",#lightR,CR)
    NEXT i
  HIGH whiskerLedR_        'eyeR off
'set threshold at 60%
  lightL =lightL *3 /5        '60%
  lightR =lightR *3 /5        '60%
  SERTXD("holethresh L",#lightL," R",#lightR,CR)
  WRITE DholedetectL,lightL
  WRITE DholedetectR,lightR
  RETURN

QGwhiskerL:
  LOW whiskerLedL_                'eyeL on
  PAUSE 1
  READADC whiskerL,whisklit
  HIGH whiskerLedL_               'eyeL off
  READ DholedetectL,temp0
  SERTXD(CR,"L=",#temp0,"/",#whisklit," ")
  IF whisklit<temp0 THEN
    obstacles =obstacles OR %10   'a hole
   ENDIF
  RETURN

QGwhiskerR:
  LOW whiskerLedR_                'eyeR on
  PAUSE 1
  READADC whiskerR,whisklit
  HIGH  whiskerLedR_              'eyeR off
  READ DholedetectR,temp0
  SERTXD(CR,"R=",#temp0,"/",#whisklit," ")
  IF whisklit<temp0 THEN
    obstacles =obstacles OR %01   'a hole
   ENDIF
  RETURN
'-----------------------------------------
'=================================================================
