Bambino_34:
SERTXD("B34",CR)    'report program number @4800

'1608 bytes

#PicAxe 20M2
#no_data
'=================================================================
'PICAXE            IC   Memory   ext  I/O   Outputs  Inputs  ADC  Memory                        Starts  Polled  Resonator
'    Type        pins  bytes    slot pins                        Vars. RAM Spad Data     Table*        Int.    def. opt.
'2.28 PICAXE-20M2  20    2k           18    1-16     1-17     4    28   512      256      512   8       Yes      4   -32

'PICAXE-20M2 circuit board with LEDs off takes 1mA
'PICAXE-20M2 circuit board with LEDs off and servos connected takes 10mA
'=================================================================

Bambino_Suite:
'Bambino-01  Test eyeLEDs, whiskerLEDs and speaker
'Bambino-02  Test PWM of eyeLEDs
'Bambino-03  Test InfraRed input
'Bambino-04  Test Eye light values
'Bambino-05  Test Whisker light values
'Bambino-06  Play the inbuilt tunes using keys 1 to 4 and beep on 5
'Bambino-07  Set servos to mid position
'Bambino-08  Calibrate servo mid positions and put in EEPROM.
'Bambino-08+ Adjust servo mid positions from Handset and put in EEPROM.
'Bambino-09  Introduce _iStand:- initialise with feet in mid position
'Bambino-10  Set rollby, rollbymax for Roll Right
'Bambino-11  Check rollby, rollbymax for Roll Left
'Bambino-12  Check rollby and rollbymax for rollL, rollR
'            save rollbyL and rollbyR in EEPROM
'Bambino-13  Introduction of _Stand
'Bambino-14  Investigate effect of rollspeed;
'            watch roll for all three speeds
'Bambino-15  Investigate effect of rollspeed;
'            watch Roll and Stand for all three speeds
'Bambino-16  Check paceFL paceFR;  Investigate effect of pacespeed
'Bambino-17  Check Fd
'Bambino-18  Test Rt, Lt
'Bambino-19  Test Bk
'Bambino-20  Test T2l: TurntoLight: T2d:  TurntoDark: Wl: Wd:
'Bambino-21  Creaton of sections ACTIONS, BEHAVIOURS, ACTS;
'            Introduction of ACT parameter 'Ado'
'Bambino-22  Demo routine + example use of Start1: to flash eyes
'Bambino-23  Walk Fd with obstacles avoidance using eyes from 04,
'            introduction of Default behaviour
'Bambino-24  Walk Fd with obstacles avoidance as 23, with Act BT
'Bambino-25  Walk Fd with drop-off avoidance using whiskers from 05
'Bambino-26  rewritten with reading of whiskers as subroutines
'Bambino-27  rewritten with autocalibration of down whiskers
'Bambino-28  Test maximum PWM and hence minimum brightness of eyeLEDs,
'            needed in Bambino-29
'Bambino-29  Wait for IR command then do it otherwise WANDER as B24
'Bambino-30  rewrite to clearer code
'Bambino-31  remember a sequence of key presses on IR-controller
'Bambino-32  remember up to 7 sequences of key presses in RAM, 
'            forgotten on power off
'Bambino-33  remember up to 8 sequence of key presses in EEPROM,
'            now not forgotten.
'            Data can now be sent to a PC.
'Bambino-34  obstacles memory made deeper for better obstacle avoidance,
'            and put in RAM, Mfrus_obs introduced

'-----------------------------------------------------------------
Rationale:
'In earlier programs the obstacle map was forgotten each time round
'the WANDER loop.
'In this program two RAM variables RAMobstaclesL and RAMobstaclesR
'remember obstacles from one loop to the next.
'Each time an obstacle is seen the relevant variable is incremented 
'by 2, and each time round the loop both variables are decremented by 1.
'If obstacles are seen repeatedly then the memmory gets stronger and 
'will last longer. When the memory reaches a certain level Bambino will
'turn with a backwards step.
'A limit is set as to how strong the memory can get
'=================================================================
Modified_and_New:
'modified
'--------
'Walk: on obstacle gosub Fd,Lt,Rt,Bk  etc
'moved to Walkabout:
'obstacles renamed Mmap_obs     Memory Map for Obstacles
'obsdetectX renamed obsclearX
'QEwhiskerR:
'QEwhiskerL

'New
'---
'Qwalk:  'Query, walk
'SYMBOL RAMobstacleR =32  'RAM  obstacle memory
'SYMBOL RAMobstacleL =33  'RAM  obstacle memory
'SYMBOL Minc_obs  'Memory increment per obstacle
'SYMBOL Mmax_obs  'Memory limit for obstacles
'SYMBOL Mfrus_obs 'level above which back direction is selected for turns
'=================================================================
BambinoCommands:
'[KEY_BAR] enters learn mode
'[KEY_BAR] has to be followed by a number key 1-8
'  = the Act to be remembered
'up to 8 Acts can be learned
'learned Acts can call subroutine Acts (SAct)
'a learned Act which chains itself repeats forever, eg #1 = Fd,1
'Acts can chain to other Acts, eg Fd,Bk,2   - chain to Act2
'[KEY_POWER] stops the playing Act.
'[KEY_TENT] selects SActs,
'[KEY_TENT] has to be followed by a number key 1-8
'   [key1]=>RockAdo
'SActs play until the end.
'
'[KEY_XCROSS]      'Dump EEPROM Acts DATA to PC
'
'When recording an Act,
'  if [1],[2],[3],[4],[5],[6],[7]
'  are used to chain another Act there is no point in recording more moves
'  because they will never be replayed since control is transfered to the new Act,
'  just press [KEY_POWER] to end recording.
'  or [1]-[8] to jump to the new Act
'  or [KEY_TENT] then [1]-[8] to do a SAct before finishing the original Act
'  when the memory slot is full Bambino will beep and recording will end.
'=================================================================
TVR010_PicAxe_IR_controller:
'---------------------------
'Before use, the transmitter must be programmed with the Sony transmit code.
'1. Insert 2 AAA size batteries, preferably alkaline.
'2. Press S and B at the same time. S is in the centre of the arrows.
'  The top left red LED should light.
'3. Press 0. The LED should flash.
'4. Press 1. The LED should flash.
'5. Press 3. The LED should go out.
'6. Press the red power button (top right).
'-------------------------------------------
'IRin cmnds PicAxe controller
'DO NOT PRESS OTHER KEYS
'ie [A] [B] [C] [D] [E] [F] [G]
'They change the Mode and [B] has to be pressed to change back.
'[square] [triangle] [()] [L] [X] [backwards F]  have no effect

SYMBOL KEY_POWER  = 21    'Sleep

SYMBOL KEY_UP     = 16    'Step Forward
SYMBOL KEY_DOWN   = 17    'Step Backward
SYMBOL KEY_RIGHT  = 18    'Turn Right
SYMBOL KEY_LEFT   = 19    'Turn Left

SYMBOL KEY_BAR    = 96    'learn an Act, next [key] selects an Act
SYMBOL KEY_TENT   = 54    'next [key] selects a Subroutine-Act
SYMBOL KEY_VERT_CROSS = 37  'use synonym for easier coding
SYMBOL KEY_VCROSS = 37
SYMBOL KEY_DIAG_CROSS = 20  'use synonym for easier coding
SYMBOL KEY_XCROSS = 20    'transfer EEPROM to PC for including in programs    '
                          '    -- Subroutine-Act and Commands --
SYMBOL IRkey1     =  0    '    RockADo
SYMBOL IRkey2     =  1
SYMBOL IRkey3     =  2
SYMBOL IRkey4     =  3
SYMBOL IRkey5     =  4
SYMBOL IRkey6     =  5
SYMBOL IRkey7     =  6
SYMBOL IRkey8     =  7
SYMBOL IRkey9     =  8
SYMBOL KEY_MINUS  = 98
SYMBOL KEY_0      =  9    'QUIT command mode
SYMBOL KEY_PLUS   = 11
'=================================================================
PIN_MAPPING:

SYMBOL servopace    =c.0  'left connector
SYMBOL servoroll    =c.4  'right connector
SYMBOL VoiceLed_    =c.5  'low =>LED on
SYMBOL eyeLedL_     =c.2  'low =>LED on
SYMBOL eyeLedR_     =b.1  'low =>LED on
SYMBOL whiskerLedL_ =c.3  'low =>whisker LED on
SYMBOL whiskerLedR_ =b.3  'low =>whisker LED on
SYMBOL eyeR         =c.7  'adc
SYMBOL eyeL         =c.1  'adc
SYMBOL whiskerL     =b.5  'adc whisker Down Left
SYMBOL whiskerR     =b.0  'adc whisker Down Right
SYMBOL inIR         =c.6
SYMBOL outIR        =b.2
'-----------------------------------------
VARIABLES_and_CONSTANTS:

SYMBOL tempW0     =W0
SYMBOL  temp0       =B0   'initialise: walk:
SYMBOL  tempLo      =B0
SYMBOL  eyelit      =B0   'QEwhiskerX
SYMBOL  temp1       =B1
SYMBOL  tempHi      =B1
SYMBOL  whisklit    =B1   'QGwhiskerX
'SYMBOL tempW1     =W1
SYMBOL cmnd         =B2
SYMBOL IRcmnd       =B2   'cmnd from IRremote
SYMBOL B_flags      =B3
'SYMBOL f_doIRcmnds
SYMBOL  f_play       =bit28 '1=playing
SYMBOL  f_record     =bit29 '1=recording
SYMBOL  f_direction  =bit30 'currrent direction Fd=1, Bk=0
SYMBOL  f_Bfast      =bit31 'speed Behaviour 1=use B_fast:
SYMBOL Scentre    =W2
SYMBOL  rollC       =B4  '100 is roll to the left, 200 to the right
SYMBOL  paceC       =B5  '100 is left foot back, 200 left foot forward
SYMBOL Sat        =W3    'current servo positions
SYMBOL  rollat      =B6
SYMBOL  paceat      =B7
SYMBOL Sto        =W4    'desired servo positions
SYMBOL  rollto      =B8
SYMBOL  paceto      =B9
SYMBOL Sspeed     =W5
SYMBOL  rollspeed   =B10 '4 is too fast, 0 won't move
SYMBOL  pacespeed   =B11 '6 is about max for servos to keep up
SYMBOL Smoveby    =W6
SYMBOL  rollby      =B12 '+ve right 15 good for walking
SYMBOL  paceby      =B13 '+ve Left foot forward 20@speed 3; 25@speed 1
SYMBOL Light      =W7
SYMBOL  lightR      =B14 'light level Right
SYMBOL  lightL      =B15 'light level Left
SYMBOL counters   =W8
SYMBOL  i           =B16 '_iStand:
SYMBOL  spulse      =B16 'FOR NEXT counter for servo pulses
SYMBOL  iA          =B17 'counter for Acts
'W9
SYMBOL Ado          =B18 'parameter for Acts
SYMBOL Mmap_obs     =B19 '%11 bitmap of obstacles  %LeftRight
'w10
SYMBOL Act          =B20
SYMBOL Apend        =B21 'Penultimate end of record slot
'w11
SYMBOL eptr         =B22  'pointer to EEPROM


SYMBOL rollbymax    =20 'rollmax absolute max is 40,
                        'above that the tilt rods hit the body
                        '@speed 3; 25@speed 1
SYMBOL pacebymax    =30 'pacebymax absolute max is 30,
                        'above that the tilt rods hit the rear femur
                        'and the horn screws hit the leg body
SYMBOL sframe       =20 'time between servo pulses
  'depending on the sensors obsclearL and obsclearR may need to be different
SYMBOL obsclearL    =20 '% light level difference > for obstacle
SYMBOL obsclearR    =20 '% light level difference > for obstacle
  'depending on the sensors holedetectL and holedetectR may need to be different
  'If there is close artificial light then Bambino may need an eye shade or a neb to shield the ground from the artificial light.
SYMBOL holedetectL  =2  'light level difference for holes
SYMBOL holedetectR  =2  'light level difference for holes
  'edit holedetect values so Bambino can see table edges
  'whisker LEDs on, 82R 1.414v =>17.2mA @4.02V
SYMBOL Minc_obs     =2  'increment  for obstacle
SYMBOL Mmax_obs     =4  'limit to obstacle memory
SYMBOL Mfru_obs     =2  'level above which back direction is selected for turns
'-----------------------------------------
'EEPROM Acts, start addresses
SYMBOL act0s  =0     ' 0-31
SYMBOL act1s  =32    '32-63
SYMBOL act2s  =32 *2 '64-95
SYMBOL act3s  =32 *3 '96-127
SYMBOL act4s  =32 *4 '128-159
SYMBOL act5s  =32 *5 '160-191
SYMBOL act6s  =32 *6 '192-223
SYMBOL act7s  =32 *7 '224-251  - EEPROM config DATA 252,253,254,255

'If [KEY_XCROSS] is used to dump to a PC EEPROM Acts DATA from another Bambino
'then paste it here

'EEPROM config data
SYMBOL DrollbyR     =252
SYMBOL DrollbyL     =253
SYMBOL DrollC       =254
SYMBOL DpaceC       =255
'-----------------------------------------
'RAM data
SYMBOL RAMholedetectR =32
SYMBOL RAMholedetectL =33
SYMBOL RAMobstaclesR  =34
SYMBOL RAMobstaclesL  =35
'=================================================================
INITIALISE:
init_rollCpaceC:
  rollC =150  'Default, 100 is roll to the left, 150 is nominal centre
  paceC =150  'Default, 100 is left foot back,   150 is nominal centre
  'get values from EEPROM if set by program #8 or #8+
  READ DrollC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    rollC =temp0
   ELSE
    WRITE DrollC,rollC             'save default for other programs
   ENDIF
  READ DpaceC,temp0
  IF temp0>130 AND temp0<170 THEN  'only load valid values
    paceC =temp0
   ELSE
    WRITE DpaceC,paceC             'save default  for other programs
   ENDIF
  SERTXD("rollC=",#rollC," paceC=",#paceC,CR)

  HIGH eyeLedR_    'make output and OFF
  HIGH eyeLedL_    'make output and OFF
  GOSUB _iStand    'stand and initialise rollat, paceat

  'rollby     =15   '+ve right good for walking, READ from EEPROM
  paceby     =25   '+ve Left  foot forward

initmind:
  GOSUB B_fast
  f_record =0
  POKE RAMobstaclesR,0  'init obstacles memory
  POKE RAMobstaclesL,0  'init obstacles memory

  GOSUB beep255    'so we know Bambino started, leaves VoiceLED on

START:
  SERTXD("S")
  Ado =4        'for RockAdo
  IRIN [50,WANDER],inIR,cmnd'IRIN with timeout, no IR =>Walkabout
  GOTO DoCmnd
'=================================================================
ACTIVITIES:

WaitIRcmnd:
SERTXD("IR")
  GOSUB EyesDimmest
  IF f_record=1 THEN
    LOW VoiceLED_
    GOSUB EyesOFF
   ENDIF                  'mouth lit
  IRIN inIR,cmnd          'Get cmnd

GotCmnd:
  GOSUB beep50            'so we know IR received

DoCmnd:
SERTXD(CR,#cmnd," @",#eptr)
SERTXD(" f_p",#f_play," f_r",#f_record,",")

  SELECT cmnd
    CASE KEY_POWER
      IF f_record=0 AND f_play=0 THEN
        GOSUB rest
        GOTO GotCmnd      'have already got IRcmnd in rest:
       ELSE
        f_play =0
        IF f_record=1 THEN
          f_record =0
          WRITE eptr,255   'end marker
         ENDIF
        'GOSUB dump        'debug
       ENDIF
    CASE KEY_UP
      GOSUB Fd
    CASE KEY_DOWN
      GOSUB Bk
    CASE KEY_RIGHT
      GOSUB Rt
    CASE KEY_LEFT
      GOSUB Lt
    CASE KEY_0
      GOTO WANDER

    CASE <IRkey9         'keys [1]-[8] => cmnd 0-7 Acts 1-8
      IF f_record<>1 THEN
        f_play=1         'play
        eptr =32 *cmnd   'set to start
        SERTXD("play@",#eptr,CR)
      ENDIF

    CASE KEY_BAR
      f_play =0
      F_record =1
      LOW VoiceLED_        'mouth lit for record
      GOSUB IRgetAct_cmnd
      eptr =32 *cmnd
      Apend =eptr +31 MAX 253 'to avoid overwriting EEPROM config DATA
      GOSUB nokey
      SERTXD("rec@",#eptr,CR)
      GOTO WaitIRcmnd      'get cmnds

    CASE KEY_TENT          'subroutine acts
      GOSUB IRgetAct_cmnd
      cmnd =cmnd +128      'set topbit for subroutine Acts
      SERTXD(" Act",#cmnd,CR)
      GOTO DoCmnd          'already beeped

    CASE KEY_XCROSS        'Dump sends DATA to PC, include Config Data
      FOR Act=0 TO 7
        SERTXD(CR,"'Slot ",#Act,CR,"DATA ")
        FOR eptr=0 TO 30
          temp0 =Act *32 +eptr            
          READ temp0,cmnd
          SERTXD(#cmnd,",")
         NEXT eptr
        temp0 =Act *32 +31
        READ temp0,cmnd
        SERTXD(#cmnd)
       NEXT Act
      SERTXD(CR)

    CASE >127
      SERTXD("case >127",CR)
      Act =cmnd -128
      ON Act GOSUB RockAdo  'add others

    END SELECT

'-------------
recordAct:
  IF f_record=1 THEN
    IF eptr<Apend THEN
      WRITE eptr,cmnd
      eptr =eptr +1
     ELSE              'end of slot
      GOSUB beep255
      GOSUB beep255
      cmnd =KEY_POWER  'force end
      GOTO DoCmnd
     ENDIF
   ENDIF

playAct:
  IF f_play=1 THEN
    IRin [50,_playon],inIR,cmnd
    GOTO GotCmnd       'if IR REceived =>break
_playon:
    GOSUB EyesOFF
    READ eptr,cmnd
    Eptr =eptr +1
    IF cmnd<>255 THEN  DoCmnd  '255=end
    f_play =0
   ENDIF

  GOTO WaitIRcmnd          'get IR

'-----------------------------------------
WANDER:
SERTXD(CR,"W")
  GOSUB EyesOFF
DecayMemory:
  PEEK RAMobstaclesR,tempLo  'read memory
  PEEK RAMobstaclesL,tempHi  'read memory
  tempLo =tempLo MIN 1 -1    'decay memory
  tempHi =tempHi MIN 1 -1    'decay memory
  POKE RAMobstaclesR,tempLo  'save
  POKE RAMobstaclesL,tempHi  'save
  SERTXD (" obL",#tempHi," obR",#tempLo,CR)

QEwhiskerL:
  READADC eyeL,lightL
  LOW eyeLedL_              'eyeL on
  PAUSE 1
  READADC eyeL,eyelit
  HIGH  eyeLedL_            'eyeL off
  eyelit =eyelit MIN lightL 'shouldn't be darker with LED on
  eyelit =eyelit MIN 1  'if eyelit=0 then eyelit=255 which is wrong
  eyelit =eyelit -lightL *100 /eyelit 'find difference as %
  SERTXD(" Lw=",#eyelit," ")
  IF eyelit>obsclearL THEN
    PEEK RAMobstaclesL,temp1
    temp1 =temp1 +Minc_obs MAX Mmax_obs
    POKE RAMobstaclesL,temp1  'update memory
   ENDIF

QEwhiskerR:
  READADC eyeR,lightR
  LOW eyeLedR_              'eyeR on
  PAUSE 1
  READADC eyeR,eyelit
  HIGH  eyeLedR_            'eyeR off
  eyelit =eyelit MIN lightR 'shouldn't be darker with LED on
  eyelit =eyelit MIN 1      'if temp=0 then temp=255 which is wrong
  eyelit =eyelit -lightR *100 /eyelit 'find difference as %
  SERTXD("Rw=",#eyelit,CR)
  IF eyelit>obsclearR THEN
    PEEK RAMobstaclesR,temp1
    temp1 =temp1 +Minc_obs MAX Mmax_obs
    POKE RAMobstaclesR,temp1    'update memory
   ENDIF

BuildMap:
  PEEK RAMobstaclesR,tempLo  'read memory
  PEEK RAMobstaclesL,tempHi  'read memory
  SERTXD (" obL",#tempHi," obR",#tempLo,CR)
  Mmap_obs =0
  'alter LEDs so we can tell what Bambino is thinking
  IF tempLo>0 THEN    'create short term memory map
    Mmap_obs =Mmap_obs OR %01
    LOW eyeLedR_       'default state is high => off
   ENDIF
  IF tempHi>0 THEN
    Mmap_obs =Mmap_obs OR %10
    LOW eyeLedL_       'default state is high => off
   ENDIF
  tempHi =tempHi +tempLo
  IF tempHi>Mfru_obs THEN
    f_direction =0
   ENDIF               'frustrated

Walk:
  ON Mmap_obs GOSUB Fd,Lt,Rt,BT

Qwalk:
  irin [50,WANDER],inIR,cmnd  'irin with timeout, no IR =>WANDER
  GOTO GotCmnd                   'QUIT if IRin

'=================================================================
BEHAVIOURS:
'----------
B_fast:
  pacespeed  =6    '6 is about max for servos to keep up
  rollspeed  =3    'half of pacespeed is about right for walking
  f_Bfast =1
  RETURN
'B_medium:
'  rollspeed =2
'  pacespeed =3
'  RETURN
'B_slow:
'  rollspeed =1
'  pacespeed =1
'  RETURN
B_turn:
  rollspeed =1  'slow so foot doesn't bounce
  pacespeed =5
  RETURN
'=================================================================
PROGRAM_ACTS:
'-----------

RockAdo:  '#128
  IF f_Bfast=1 THEN GOSUB B_fast
  FOR iA=1 TO Ado
     GOSUB _rollR
    GOSUB _rollL
   NEXT iA
  GOSUB Stand
  RETURN

FdAdo:
  FOR iA=1 TO Ado
    GOSUB Fd
   NEXT iA
  RETURN

BkAdo:
  FOR iA=1 TO Ado
    GOSUB Bk
   NEXT iA
  RETURN

BT:
  GOSUB Bk
  GOSUB Bk
  GOSUB Rt
  GOSUB Rt
  RETURN

Rest:
  GOSUB _rollL
  GOSUB _iStand
  GOSUB EyesDimmest
  HIGH whiskerLedL_
  HIGH whiskerLedR_
  HIGH VoiceLed_
_RestIRin:
  IRIN inIR,cmnd    'IRIN with no timeout
  RETURN

'=================================================================
ACTIONS:
'-------

Fd:
SERTXD ("Fd")
  f_direction =1
  IF f_Bfast=1 THEN GOSUB B_fast
  IF paceat<paceC THEN _FdL 'else _FdL
_FdR:
'SERTXD ("_FdR")
  GOSUB _rollL
  GOSUB _RF
  GOSUB Stand
  RETURN
_FdL:
'SERTXD ("_FdL")
  GOSUB _rollR
  GOSUB _LF
  GOSUB Stand
  RETURN
'-----------------------------------------
Bk:
SERTXD ("Bk")
  f_direction =0
  IF f_Bfast=1 THEN GOSUB B_fast
  IF paceat<paceC THEN _BkR 'else _BkL
_BkL:
  GOSUB _rollR
  GOSUB _RF
  GOSUB Stand
  RETURN
_BkR:
  GOSUB _rollL
  GOSUB _LF
  GOSUB Stand
  RETURN
'-----------------------------------------
Rt:
SERTXD ("Rt")
  IF paceat<paceC AND f_direction=1 THEN GOSUB Fd  'need left foot forward
  IF paceat<paceC AND f_direction=0 THEN GOSUB Bk  'need left foot forward
  IF f_Bfast=1 THEN GOSUB beep255
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _RF
  RETURN
'-----------------------------------------
Lt:
SERTXD ("Lt")
  IF paceat>paceC AND f_direction=1 THEN GOSUB Fd  'need right foot forward
  IF paceat>paceC AND f_direction=0 THEN GOSUB Bk  'need right foot forward
  IF f_Bfast=1 THEN GOSUB beep255
  IF f_Bfast=1 THEN GOSUB B_turn
  GOSUB _LF
  RETURN
'=================================================================
MOVEMENTS:
'---------

_RF:
'SERTXD ("_RF")
  paceto =paceC -paceby
  FOR spulse=paceat TO paceto STEP -pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_LF:
'SERTXD ("_LF")
  paceto =paceC +paceby
  FOR spulse=paceat TO paceto STEP pacespeed
    paceat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
'-----------------------------------------
Stand:  'stand with both feet flat
'SERTXD (" Sd")
  IF rollat<rollC THEN _StandR 'else _StandL
_StandL:
'SERTXD ("_SL")
  FOR spulse=rollat TO rollC STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
_StandR:
'SERTXD ("_SR")
  FOR spulse=rollat TO rollC STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
'-----------------------------------------
_rollL:
'SERTXD ("_rL")
  READ DrollbyL,rollby
  rollto =rollC -rollby
  FOR spulse=rollat TO rollto STEP -rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN

_rollR:
'SERTXD ("_rR")
  READ DrollbyR,rollby
  rollto =rollC +rollby
  FOR Spulse=rollat TO rollto STEP rollspeed
    rollat =spulse
    GOSUB pulseservos
   NEXT spulse
  RETURN
'-----------------------------------------
pulseservos:
  PULSOUT servoroll,rollat  'pulse servo
  PULSOUT servopace,paceat  'pulse servo
  PAUSE sframe
  RETURN
'-----------------------------------------
_iStand:
'initialise with feet in mid position
  FOR spulse=0 TO 10
    PULSOUT servopace,paceC  'pulse servo paceC
    PULSOUT servoroll,rollC  'pulse servo rollC
    PAUSE 70        'pause 70ms - do it slowly
   NEXT spulse
  rollat =rollC
  paceat =paceC
  RETURN
'=================================================================
COMMUNICATION:  'HMI - Human Machine Interface
'---------------------------------------------

beep50:
  SOUND VoiceLed_,(50,10)
  HIGH VoiceLed_
  RETURN

beep255:
  SOUND VoiceLed_,(255,10)
  HIGH VoiceLed_
  RETURN

EyesOFF:
  pwmout eyeLedR_,off
  pwmout eyeLedL_,off
  HIGH eyeLedR_
  HIGH eyeLedL_
  RETURN

EyesON:
  LOW eyeLedR_
  LOW eyeLedL_
  RETURN

EyesDimmest:
  pwmout eyeLedR_,255,1023 'active low so high Dutycycle for dim,
  pwmout eyeLedL_,255,1023 'active low so high Dutycycle for dim,
  RETURN
'=================================================================
UTILITIES:
'---------

IRgetAct_cmnd:
  IRIN inIR,cmnd      'key1 - key8 => 0-7
  IF cmnd<8 THEN _IRgetActEnd
  IF cmnd=KEY_POWER THEN RETURN ENDIF  'quit
  GOSUB badkey
  GOTO IRgetAct_cmnd  'repeat until valid act
_IRgetActEnd:
  GOSUB beep50
  RETURN

nokey:
  IRIN [50,_nokeyend],inIR,cmnd'IRIN timeout =>reurn
  GOTO nokey
_nokeyend:
  RETURN

badkey:
  LOW whiskerLedR_
  PAUSE 100
  HIGH whiskerLedR_
  LOW whiskerLedL_
  PAUSE 100
  HIGH whiskerLedL_
  RETURN
'=================================================================
SENSE:
'-----

calibrateholewhiskers:
  Light =0  'clear temp Hi Lo
'take averages of 8 readings per whisker
  LOW whiskerLedL_        'eyeL on
  FOR i=0 TO 7
    READADC whiskerL,temp0
    SERTXD("L",#temp0)
    temp0 =temp0 /8
    lightL =lightL +temp0
    SERTXD(" ",#lightL,CR)
   NEXT i
  HIGH whiskerLedL_       'eyeL off
  LOW WhiskerLedR_        'eyeR on
  FOR I=0 TO 7
    READADC whiskerR,temp0
    SERTXD("R",#temp0)
    temp0 =temp0 /8
    lightR =lightR +temp0
    SERTXD(" ",#lightR,CR)
   NEXT i
  HIGH whiskerLedR_        'eyeR off
'set threshold at 60%
  lightL =lightL *3 /5        '60%
  lightR =lightR *3 /5        '60%
  SERTXD("holethresh L",#lightL," R",#lightR,CR)
  POKE RAMholedetectL,lightL
  POKE RAMholedetectR,lightR
  RETURN

QGwhiskerL:
  LOW whiskerLedL_                'eyeL on
  PAUSE 1
  READADC whiskerL,whisklit
  HIGH whiskerLedL_               'eyeL off
  PEEK RAMholedetectL,temp0
  SERTXD(CR,"L=",#temp0,"/",#whisklit," ")
  IF whisklit<temp0 THEN
    Mmap_obs =Mmap_obs OR %10   'a hole
   ENDIF
  RETURN

QGwhiskerR:
  LOW whiskerLedR_                'eyeR on
  PAUSE 1
  READADC whiskerR,whisklit
  HIGH  whiskerLedR_              'eyeR off
  PEEK RAMholedetectR,temp0
  SERTXD(CR,"R=",#temp0,"/",#whisklit," ")
  IF whisklit<temp0 THEN
    Mmap_obs =Mmap_obs OR %01   'a hole
   ENDIF
  RETURN

'=================================================================